/**
 * Created by erdem on 20.10.2016.
 */
myApp.onPageInit('message_box', function (page) {
    $$('.back').on('click', function () {
        if (getConfigReload) {
            getConfigReload = false;
            KV.getConfig();
            return false;
        }
        mainView.router.back({url: 'main.html', force: true})

    });

    $$('.navbar').removeClass('transparent').addClass('backgroundBlue');
    var is_contact_exhibitor_person = JSON.parse((localStorage.getItem("userData"))).allUserData.contact_exhibitor_person;

    //console.log(page.context);
    if (page.context.conversationLength > 0) {
        var conversationArray = [];
        var otherArr = [];
        $$.each(page.context.conversations, function (index, value) {
            var me = null;
            var other = null;
            var unread = 0;
            if (activeID == value.first_contact.value) {
                me = value.relatedData.first_contact;
                other = value.relatedData.second_contact;
                other.photo_location = 'event_registration/grp_' + value.rel_second_contact__profile_photo_group;
                other.only_group = value.rel_second_contact__profile_photo_group;
                unread = value.first_contact_unread;
            } else if (activeID == value.second_contact.value) {
                me = value.relatedData.second_contact;
                other = value.relatedData.first_contact;
                other.photo_location = 'event_registration/grp_' + value.rel_first_contact__profile_photo_group;
                other.only_group = value.rel_first_contact__profile_photo_group;
                unread = value.second_contact_unread;
            }

            if (other !== null) {
                otherArr[other.record_id] = other;
                if (!other.profile_photo) {
                    rProfilPhoto = 'img/noPhoto.png'
                } else {
                    rProfilPhoto = 'https://app.kivacrm.com/accounts/kvacc5371/data/photo/event_registration/grp_' + other.only_group + '/orj_' + other.profile_photo;
                }

                var name = null;

                if (!is_contact_exhibitor_person && other.contact_exhibitor_person) {
                    name = other.organization.label;
                } else if (is_contact_exhibitor_person) {
                    name = other.firstname + ' ' + other.lastname;
                }

                var userType = null;
                var color = null;
                if (other.show_only_users) {
                    userType = (other.show_only_users.value == 5) ? 'Veli' : (other.show_only_users.value == 2) ? 'Öğretmen' : (other.show_only_users.value == 3) ? 'Öğrenci' : '&nbsp;';
                    color = (other.show_only_users.value == 5) ? '#BADA55' : (other.show_only_users.value == 2) ? '#80aaff' : (other.show_only_users.value == 3) ? '#ff99ff' : '';
                }

                if (name) {
                    var item = {
                        name: name,
                        last_message: value.last_message,
                        profile_photo: rProfilPhoto,
                        conversation_label: value.conversation_label,
                        other_record_id: other.record_id,
                        last_message_date: dformat(value.last_message_date),
                    };
                    item.unread = (unread) ? '<div class="badgeSpan">' + unread + '</div>' : '';
                    conversationArray.push(item);
                    item.userType = (userType) ? '<div class = "uType">' + userType + '</div>' : '';
                    item.userType2 = (userType) ? '<div class = "uType2">' + userType + '</div>' : '';
                    other.unread = item.unread;
                    other.userType2 = item.userType2;
                }
                otherArr[other.record_id] = other;

            }
        });

        function dformat(last_message_date) {
            if (!last_message_date) {
                last_message_date = "2017-01-01 00:30:00";
            }
            var time_ = (last_message_date.substr(11, 5));

            console.log(time_);

            var now = new Date();
            var today = makeYMD(now);
            var yesterday = makeYMD(new Date(now.setDate(now.getDate() - 1)));
            last_message_date = makeYMD(new Date(last_message_date));
            if (today == last_message_date) {
                last_message_date = "Bugün";
            } else if (yesterday == last_message_date) {
                last_message_date = "Dün";
            }
            return last_message_date + "\n" + time_;
        };


        function makeYMD(d) {
            dt = [d.getDate().padLeft(),
                (d.getMonth() + 1).padLeft(),
                d.getFullYear()].join('.');
            return dt;
        }

        // function getYesterday(d) {
        //     return new Date(d.setDate(d.getDate() - 1));
        // }

        var height = 89;
        /*if (!is_contact_exhibitor_person) {
         height = 68;
         }*/

        var myList = myApp.virtualList('.list-block.virtual-list', {
            // Array with plain HTML items
            items: conversationArray,
            height: height,
            // Template 7 template to render each item
            template: '<li class="item-content msgLi" conversation_label="{{conversation_label}}" other_record_id="{{other_record_id}}">' +
            '<div class="item-media asd" style="padding-left: 0"><img class="circular" width="44" src="{{profile_photo}}">{{unread}}</div>' +
            '<div class="item-inner">' +
            '            <div class="item-title-row" style="">' +
            '<div class="item-title">{{name}}</div>' +
            '<div class="item-after" style="white-space: pre;font-size: 0.8em;">{{last_message_date}}</div> ' +
            '</div>' +
            '<div class="item-subtitle" style="max-width: 50%" >{{userType}}</div>' +
            '<div class="item-subtitle" style="color:#E0E0E0">{{last_message}}</div>' +
            '</div>' +
            '</li>'
        });

        var el = $$(".list-block.virtual-list").find("ul").css("background", "rgba(0, 0, 0, 0.33)");
        console.log(el);


        $$('.msgLi').on("click", function () {
            var conversation_label = $$(this).attr("conversation_label");
            var toParticipantId = $$(this).attr("other_record_id");
            var toParticipant = otherArr[toParticipantId];
            var params = {
                conversation_label: conversation_label,
                toParticipant: toParticipant,
                toParticipantId: toParticipantId,
                toBack: 'message_box.html',
                isContactPerson: is_contact_exhibitor_person,
                reload: page.context.reload,
                reloadData: page.context.reloadData
            };


            KV.activeConversationParams = params;
            KV.toConverstaion(params);
        });
    }

});