/**
 * Created by erdem on 24.09.2016.
 */


myApp.onPageInit('profileQuestion', function (page) {
    console.log(page.context);
    var checkedCount = 0;

    $$('#adBanner').show();

    if (page.context.pollAnswers.length >= 20) {
        var mySearchbar = myApp.searchbar('.searchbar', {
            searchList: '.list-block-search',
            searchIn: '.item-title'
        });
    }


    $$("[type=search]").keyup(function (event) {
        KV.trUpperCase(this);
    });

    $$('.poll-check').change(function () {
        if ($$(this).is(":checked")) {
            if (checkedCount + 1 > page.context.pollMaxSelect) {
                $$(this).prop('checked', false);
                myApp.alert("En fazla " + page.context.pollMaxSelect + " seçim yapabilirsiniz", "Dikkat!");
            } else {
                checkedCount++;
                $$(this).parent().css("background", "#ffcc03");
                $$(this).parent().css("color", "#000000");
                $$(this).parent().css("font-weight", "bold");
            }
        } else {
            $$(this).parent().css("background", "#FFFFFF");
            $$(this).parent().css("color", "#000000");
            $$(this).parent().css("font-weight", "normal");
            checkedCount--;
        }
        console.log(checkedCount);
    });


    $$('label').on("click", function () {
        console.log("asda");
        KV.dialogAnswer(this);
    });

    $$('.poll-radio').on("change", function () {
        $$('.profileQuestion label').css("background-color", "#FFFFFF");
        $$('.profileQuestion label').css("color", "#000000");
        $$('.profileQuestion label').css("font-weight", "normal");

        $$(this).parent().css("background-color", "#ffcc03");
        $$(this).parent().css("color", "#000000");
        $$(this).parent().css("font-weight", "bold");
    });

    $$('.back').on('click', function () {
        if (page.context.back) {
            mainView.router.back({url: page.context.back, force: true})
        } else {
            mainView.router.back({url: 'main.html', force: true})
        }
    });
    $$('.navbar').removeClass('transparent').addClass('backgroundBlue');


    var pqRs = {back: page.context.back};

    $$(page.container).find('#pollSave').on('click', function () {


        var ctrl = 1;
        var selected = [];
        if (page.context.pollMaxSelect < 2) {
            var pollRadio = $$('input[name="pollRadio"]:checked').val();
            if (!pollRadio) {
                ctrl = 0;
                myApp.alert("Lütfen cevap seçiniz", "Dikkat");
                return false;
            } else {
                var pollRecordObj = {
                    poll: page.context.pollId,
                    answer: pollRadio,
                    registration: activeID
                }
                if ($$('input[name="pollRadio"]:checked').attr("dialog_answer")) {
                    pollRecordObj.dialog_answer = $$('input[name="pollRadio"]:checked').attr("dialog_answer")
                }
                selected.push(pollRecordObj);
            }
        }
        else {
            $$('.label-checkbox input:checked').each(function () {
                var pollRecordObj = {
                    poll: page.context.pollId,
                    answer: $$(this).val(),
                    registration: activeID
                };
                if ($$(this).attr("dialog_answer")) {
                    pollRecordObj.dialog_answer = $$(this).attr("dialog_answer")
                }
                selected.push(pollRecordObj);
            });
            if (selected.length < 1) {
                ctrl = 0;
                myApp.alert("Lütfen cevap seçiniz", "Dikkat");
                return false;
            }
        }

        //console.log(selected);


        if (ctrl = 1) {

            //$$.each(selected, function (index, value) {
            myApp.showIndicator();


            kvapi.post("/data/event/poll_record", {
                //triggerWF: true, // iş akışı kuralı var ise çalıştır
                upsert: true, // mükerrer kayıt var ise güncelle
                upsertFields: ["poll"],
                upsertIfEmpty: true,
                records: selected

            })
                .then(function (response) {
                    //myApp.alert('Anket cevabınız kaydedilmiştir.', 'Başarılı', function () {

                    //if (selected.length == index + 1) {
                    if (!response.response.failed) {
                        myApp.hideIndicator();
                        KV.getProfilQuestion(pqRs);
                    } else {
                        KV.alertFail("Cevabınız kaydedilemiyor. Lütfen yetkiliyle görüşünüz. BYT-PQS01", "Hata");
                    }
                    //}
                    //});


                })
                .catch(function (rs) {
                    myApp.hideIndicator();
                    console.log(rs);
                });
            //});

        }
    });
});