myApp.onPageInit('quiz', function (page) {

    $$('.back').on('click', function () {
        mainView.router.back({url: 'main.html', force: true})
    });

    var quiz_datas = page.context.records;
    var data = {
        "fullname": JSON.parse((localStorage.getItem("userData"))).userName
    };

    $$('.navbar').removeClass('transparent').addClass('backgroundBlue')

    $$(page.container).find('.quiz-item').on('click', function () {

        myApp.showIndicator();
        var quiz_id = $$(this).attr("item-id");

        for (var i = 0; i < quiz_datas.length; i++) {
            if (quiz_datas[i].record_id == quiz_id) {
                data.quiz_data = quiz_datas[i];
                break;
            }
        }
        kvapi.get("/data/game/quiz_record", {
            viewId: "mobile_app",
            filters: JSON.stringify({
                "quiz": ["=", quiz_id],
                "registration": ["=", activeID]
            })
        }).then(function (cb) {
            if (cb.response.records.length > 0) {
                if (!cb.response.records[0].score) {
                    // myApp.alert("Bilgi yarışması açılırken bir hata oluştu. Lütfen yetkililerle görüşünüz.", "Hata!");
                    // return false;
                    myApp.hideIndicator();
                    cb.response.records[0].score = "0.00";
                }
                data.showQuiz = false;
                data.quiz_record_data = cb.response.records[0];

                kvapi.get("/data/game/quiz_record", {
                    viewId: "mobile_app",
                    filters: JSON.stringify({
                        "quiz": ["=", quiz_id],
                        "score_temp": [">", cb.response.records[0].score.replace(".", ",")]
                    })
                }).then(function (cb2) {
                    myApp.hideIndicator();

                    data.quiz_siralama = parseInt(cb2.response.total) + 1;

                    myApp.template7Data['page:quizWaitingPage'] = data;
                    mainView.router.load({
                        url: 'quizWaitingPage.html',
                        reload: true,
                    });

                }).catch(function (rs2) {
                    myApp.hideIndicator();

                    console.log(rs2);
                });


            } else {
                myApp.hideIndicator();

                data.showQuiz = true;
                myApp.template7Data['page:quizWaitingPage'] = data;
                mainView.router.load({
                    url: 'quizWaitingPage.html',
                    reload: true
                });
            }


        })

    });
});

myApp.onPageInit('quizWaitingPage', function (page) {
    $$('.back').on('click', function () {
        mainView.router.back({url: 'quiz.html', force: true})
    });
    var quiz_data = page.context.quiz_data;

    /*  localStorage.removeItem("quiz_global_answers_" + quiz_data.record_id);
     localStorage.removeItem("quiz_questionsEasy_" + quiz_data.record_id);
     localStorage.removeItem("quiz_questionsNormal_" + quiz_data.record_id);
     localStorage.removeItem("quiz_questionHard_" + quiz_data.record_id); */

    console.log(quiz_data);
    if (page.context.showQuiz) {
        $$('.showQuiz').css("display", "block");
        $$('.showQuiz2').css("display", "block");
        $$('.quizStartBtn').on('click', function () {
            myApp.showIndicator();
            if (!JSON.parse(localStorage.getItem("quiz_questionsEasy"))) {
                kvapi.get("/custom/educaturk/competition", {
                    viewId: "all",
                    sort: "difficulty",
                    dir: 'ASC',

                }).then(function (cb) {
                    //console.log(cb);
                    //return false;
                    myApp.hideIndicator();
                    var questions_data = cb.response.records;


                    if (questions_data.length > 0) {

                        var questions_data_arr = [];
                        questions_data_arr[0] = [];
                        questions_data_arr[0][0] = questions_data[0];
                        var ctr_difficulty = questions_data[0].difficulty;
                        var z = 0;

                        for (var i = 1; i < questions_data.length; i++) {
                            if (ctr_difficulty == questions_data[i].difficulty) {
                                questions_data_arr[z].push(questions_data[i]);
                            } else {
                                ctr_difficulty = questions_data[i].difficulty;
                                z++;
                                questions_data_arr[z] = [];
                                questions_data_arr[z].push(questions_data[i]);

                            }

                        }


                        var questions_data_easy = [];
                        var questions_data_normal = [];
                        var questions_data_hard = [];

                        var i = 0;
                        var ctr_keys_arr = [];

                        while (i < quiz_data.question_amount_easy) {
                            var ctr_key = false;
                            var key = parseInt(Math.random() * questions_data_arr[0].length, 10);

                            for (z = 0; z < ctr_keys_arr.length; z++) {
                                if (key == ctr_keys_arr[z]) {
                                    ctr_key = true;
                                    break;
                                }
                            }
                            if (!ctr_key) {
                                questions_data_easy.push(questions_data_arr[0][key]);
                                ctr_keys_arr.push(key);
                                i++;
                            }
                        }

                        var i = 0;
                        var ctr_keys_arr = [];

                        while (i < quiz_data.question_amount_medium) {
                            var ctr_key = false;
                            var key = parseInt(Math.random() * questions_data_arr[1].length, 10);

                            for (z = 0; z < ctr_keys_arr.length; z++) {
                                if (key == ctr_keys_arr[z]) {
                                    ctr_key = true;
                                    break;
                                }
                            }
                            if (!ctr_key) {
                                questions_data_normal.push(questions_data_arr[1][key]);
                                ctr_keys_arr.push(key);
                                i++;
                            }
                        }

                        var i = 0;
                        var ctr_keys_arr = [];

                        while (i < quiz_data.question_amount_hard) {
                            var ctr_key = false;
                            var key = parseInt(Math.random() * questions_data_arr[2].length, 10);

                            for (z = 0; z < ctr_keys_arr.length; z++) {
                                if (key == ctr_keys_arr[z]) {
                                    ctr_key = true;
                                    break;
                                }
                            }
                            if (!ctr_key) {
                                questions_data_hard.push(questions_data_arr[2][key]);
                                ctr_keys_arr.push(key);
                                i++;
                            }
                        }

                        var data = {
                            "quiz_data": quiz_data,
                            "question_data_easy": questions_data_easy,
                            "question_data_normal": questions_data_normal,
                            "question_data_hard": questions_data_hard
                        };

                        localStorage.setItem("quiz_questionsEasy_" + quiz_data.record_id, JSON.stringify(questions_data_easy));
                        localStorage.setItem("quiz_questionsNormal_" + quiz_data.record_id, JSON.stringify(questions_data_normal));
                        localStorage.setItem("quiz_questionHard_" + quiz_data.record_id, JSON.stringify(questions_data_hard));

                        myApp.template7Data['page:quizQuestionsPage'] = data;
                        mainView.router.load({
                            url: 'quizQuestionsPage.html',
                            reload: true,
                        });

                    }


                })

            } else {

                var data = {
                    "quiz_data": quiz_data,
                    "question_data_easy": JSON.parse((localStorage.getItem("quiz_questionsEasy_" + quiz_data.record_id))),
                    "question_data_normal": JSON.parse((localStorage.getItem("quiz_questionsNormal_" + quiz_data.record_id))),
                    "question_data_hard": JSON.parse((localStorage.getItem("quiz_questionHard_" + quiz_data.record_id))),
                };
                myApp.template7Data['page:quizQuestionsPage'] = data;
                mainView.router.load({
                    url: 'quizQuestionsPage.html',
                    reload: true
                });
                myApp.hideIndicator();
            }

        });
    } else {
        $$('.notShowQuiz').css("display", "block");
        $$('.kv_quiz_score').html(parseFloat(page.context.quiz_record_data.score).toFixed(2));
        $$('.kv_quiz_order').html(page.context.quiz_siralama);

        $$('.quizOrderList').on('click', function () {

            myApp.showIndicator();
            kvapi.get("/data/game/quiz_record", {
                viewId: "mobile_app",
                sort: 'score_temp',
                dir: 'DESC',
                start: 0,
                limit: 10,
                filters: JSON.stringify({
                    "quiz": ["=", quiz_data.record_id],
                })
            }).then(function (cb) {

                for (var i = 0; i < cb.response.records.length; i++) {
                    cb.response.records[i].sira_no = i + 1;
                }
                myApp.hideIndicator();

                mainView.router.load({
                    url: 'quizOrderList.html',
                    context: cb.response.records,
                    reload: true
                });


            }).catch(function (rs) {
                myApp.hideIndicator();
                KV.alertFail();
            });

        });
    }
});

myApp.onPageInit('quizQuestionsPage', function (page) {

    var quiz_data = page.context.quiz_data;

    var questions_length = quiz_data.question_amount_hard + quiz_data.question_amount_medium + quiz_data.question_amount_easy;
    var questions_data_easy = page.context.question_data_easy;
    var questions_data_normal = page.context.question_data_normal;
    var questions_data_hard = page.context.question_data_hard;
    var questions_ordered = questions_data_easy.concat(questions_data_normal);
    var questions_ordered = questions_ordered.concat(questions_data_hard);
    console.log(page.context);
    var global_timeInterval = 20;
    // var global_answers = [];
    if (!localStorage.getItem("quiz_global_answers_" + quiz_data.record_id)) {
        localStorage.setItem("quiz_global_answers_" + quiz_data.record_id, JSON.stringify([]));
    }
    var choosen = false;
    var choosen_last = false;

    function operation(SoruNum) {
        choosen = false;
        var html = AddQuestionHtlm(SoruNum, questions_ordered);
        $$(".quiz").html(html);
        global_timeInterval = new Date().getTime() + 20000;

        if (SoruNum <= questions_length) {
            var global_answers = JSON.parse(localStorage.getItem("quiz_global_answers_" + quiz_data.record_id));
            global_answers[parseInt(SoruNum) - 1] = {
                registration: activeID,
                quiz: quiz_data.record_id,
                question: questions_ordered[parseInt(SoruNum) - 1].record_id,
                answer_status: "1",
                remaining_time: "0"
            };
            localStorage.setItem("quiz_global_answers_" + quiz_data.record_id, JSON.stringify(global_answers));
            $$(".timeLabel").html(global_timeInterval);
        } else {
            $$(".questionCon").css("display", "block");
            window.clearInterval(timeOutVar);

        }


        $$('.questionCon').on('click', function () {
            var soru_id = $$(this).attr("soru-id");
            console.log("soru_id", soru_id);
            window.clearInterval(timeOutVar);
            // global_timeInterval = 20;
            if (parseInt(soru_id) < questions_length) {
                operation(parseInt(soru_id) + 1);
            } else {
                if (!choosen_last) {
                    myApp.showIndicator();
                    // first quiz record //
                    kvapi.post("/data/game/quiz_record", {
                        records: [
                            {
                                quiz: quiz_data.record_id,
                                registration: activeID
                            }
                        ]
                    }).then(function (cb) {
                        if (cb.status.code == 200) {
                            var record_id = cb.response.records[0].record_id;

                            var global_answers = JSON.parse(localStorage.getItem("quiz_global_answers_" + quiz_data.record_id));

                            localStorage.removeItem("quiz_global_answers_" + quiz_data.record_id);
                            localStorage.removeItem("quiz_questionsEasy_" + quiz_data.record_id);
                            localStorage.removeItem("quiz_questionsNormal_" + quiz_data.record_id);
                            localStorage.removeItem("quiz_questionHard_" + quiz_data.record_id);

                            for (var i = 0; i < global_answers.length; i++) {
                                global_answers[i].quiz_record = record_id;
                                global_answers[i].remaining_time = global_answers[i].remaining_time.replace(".", ",");
                            }


                            // quiz answers record //

                            kvapi.post("/data/game/quiz_answer", {
                                records: global_answers
                            }).then(function (cb2) {

                                // get quiz score //


                                kvapi.get("/data/game/quiz_record", {
                                    viewId: "mobile_app",
                                    filters: JSON.stringify({
                                        "game_quiz_record_id": ["=", cb.response.records[0].record_id]
                                    })
                                }).then(function (rs_get_score) {


                                    // set quiz score temp //
                                    if (!rs_get_score.response.records[0].score) {
                                        rs_get_score.response.records[0].score = "0.00";
                                    }
                                    kvapi.patch("/data/game/quiz_record", {
                                        records: [
                                            {
                                                record_id: rs_get_score.response.records[0].record_id,
                                                score_temp: rs_get_score.response.records[0].score.replace(".", ","),
                                            }
                                        ]
                                    }).then(function (rs_score_tmp) {


                                        kvapi.get("/data/game/quiz_record", {
                                            viewId: "mobile_app",
                                            filters: JSON.stringify({
                                                "quiz": ["=", rs_get_score.response.records[0].quiz],
                                                "score_temp": [">", rs_get_score.response.records[0].score.replace(".", ",")]
                                            })
                                        }).then(function (cb2) {

                                            var html = '<div class="content-block-title">TEBRİKLER ! SAYIN ' + JSON.parse((localStorage.getItem("userData"))).userName + '</div>' +
                                                '<div class="content-block">' +
                                                '<p>' + quiz_data.end_content_tr + '</p>' +
                                                '<p><strong>Sıranız:</strong> ' + (cb2.response.records.length + 1) + '</p>' +
                                                '<p><strong>Puanınız: </strong>' + rs_get_score.response.records[0].score.replace(".", ",") + '</p>' +
                                                '<a href="#" class="button demo-modals-stack mybutton quizOrderList">Sıralamayı Gör</a>' +
                                                '</div>';
                                            $$(".quiz").html(html);

                                            $$('.quizOrderList').on('click', function () {
                                                kvapi.get("/data/game/quiz_record", {
                                                    viewId: "mobile_app",
                                                    sort: 'score_temp',
                                                    dir: 'DESC',
                                                    start: 0,
                                                    limiz: 10,
                                                    filters: JSON.stringify({
                                                        "quiz": ["=", quiz_data.record_id],
                                                    })
                                                }).then(function (cb) {


                                                    for (var i = 0; i < cb.response.records.length; i++) {
                                                        cb.response.records[i].sira_no = i + 1;
                                                    }

                                                    mainView.router.load({
                                                        url: 'quizOrderList.html',
                                                        context: cb.response.records,
                                                        reload: true
                                                    });

                                                }).catch(function (rs) {
                                                    console.log(rs);
                                                });

                                            });


                                            myApp.hideIndicator();

                                        }).catch(function (rs2) {

                                            console.log(cb2);

                                        });


                                    }).catch(function (rs_score_tmp) {

                                        console.log(rs_score_tmp);

                                    });

                                })


                            }).catch(function (rs2) {
                                console.log(rs2);
                            });


                        }
                    }).catch(function (rs) {
                        console.log(rs);
                    });
                }
            }

        });

        $$('.questionChoice').on('click', function () {
            if (!choosen) {
                choosen = true;
                window.clearInterval(timeOutVar);
                var choise = $$(this).attr("choise");
                var soru_id = $$(this).attr("soru-id");
                var remaining_time = parseFloat((global_timeInterval - new Date().getTime()) / 1000).toFixed(2);
                console.log("Global Time Interval:" + global_timeInterval);
                console.log("Remaining Time:" + remaining_time);
                var answer_satatus = null;
                if (questions_ordered[parseInt(soru_id) - 1].right_answer == choise) {
                    $$(this).css("background", "#33b39b");
                    $$(this).css("color", "#fff");
                    $$(this).css("font-weight", "bold");
                    $$(".answer-callback").css("color", "#33b39b");
                    $$(".answer-callback").html("Doğru Cevap!");
                    $$(".answer-callback2").html(page.context.quiz_data.correct_answer_msg_tr);
                    $$(".questionCon").css("display", "block");
                    answer_satatus = "2";

                } else {
                    $$(this).css("background", "#9a1b2c");
                    $$(this).css("color", "#FFFFFF");
                    $$(this).css("font-weight", "bold");

                    $$(this).children().css("color", "#FFFFFF");


                    $$(".answer-callback").css("color", " ");
                    $$(".answer-callback").html("Yanlış Cevap");
                    $$(".answer-callback2").html(page.context.quiz_data.wrong_answer_msg_tr);
                    $$(".questionCon").css("display", "block");

                    answer_satatus = "3";
                }
                var global_answers = JSON.parse(localStorage.getItem("quiz_global_answers_" + quiz_data.record_id));
                global_answers[parseInt(soru_id) - 1] = {
                    registration: activeID,
                    quiz: quiz_data.record_id,
                    question: questions_ordered[parseInt(soru_id) - 1].record_id,
                    answer: choise,
                    answer_status: answer_satatus,
                    remaining_time: remaining_time
                };
                localStorage.setItem("quiz_global_answers_" + quiz_data.record_id, JSON.stringify(global_answers));
                /*  global_answers.push({
                 registration: activeID,
                 quiz: quiz_data.record_id,
                 question: questions_ordered[parseInt(soru_id) - 1].record_id,
                 answer: choise,
                 answer_status: answer_satatus,
                 remaining_time: remaining_time
                 }); */
            }
        });

        var timeOutVar = setInterval(function () {

            var time = global_timeInterval - new Date().getTime();
            var str_time = parseFloat(time / 1000).toFixed(2);
            $$(".timeLabel").html(str_time);
            if (str_time <= 0) {
                $$(".timeLabel").html("0.00");
                window.clearInterval(timeOutVar);
                choosen = true;
                var soru_id = $$(".questionCon").attr("soru-id");
                $$(".answer-callback").css("color", "#9a1b2c");
                $$(".answer-callback").html("Bu soru için süreniz doldu!");
                $$(".answer-callback2").html(page.context.quiz_data.wrong_answer_msg_tr);
                $$(".questionCon").css("display", "block");

                var global_answers = JSON.parse(localStorage.getItem("quiz_global_answers_" + quiz_data.record_id));
                global_answers[parseInt(soru_id) - 1] = {
                    registration: activeID,
                    quiz: quiz_data.record_id,
                    question: questions_ordered[parseInt(soru_id) - 1].record_id,
                    answer_status: "1",
                    remaining_time: "0"
                };
                localStorage.setItem("quiz_global_answers_" + quiz_data.record_id, JSON.stringify(global_answers));

            }
        }, 10);

    }

    if (JSON.parse(localStorage.getItem("quiz_global_answers_" + quiz_data.record_id)).length > 0) {
        operation((JSON.parse(localStorage.getItem("quiz_global_answers_" + quiz_data.record_id)).length) + 1);
    } else {
        operation(1);
    }


});

myApp.onPageInit('quizOrderList', function (page) {
    $$('.back').on('click', function () {
        mainView.router.back({url: 'quiz.html', force: true})
    });
});

function AddQuestionHtlm(soru, data) {
    var btnHtml = (soru <= data.length) ? 'YARIŞMAYA DEVAM ET' : 'YARIŞMAYI SONLANDIR';
    var html = '';
    if (soru <= data.length) {
        html =
            '<div class="row">' +
            '<div class="col-50 question"><span>Soru ' + soru + '</span></div>' +
            '<div class="col-50 timer" align="right"><img src="img/clock2.png" width="16"><span class="timeLabel"></span><span> sn</span></div>' +
            '</div>' +
            '<div class="content-block">' +
            '<p>' + data[soru - 1].question + '</p>' +
            '</div>' +
            '<div class="list-block">' +
            '<ul>' +
            '<li>' +
            '<a href="#" class="item-link item-content questionChoice" choise="1" soru-id="' + soru + '">' +
            '<div class="item-media">A)</div>' +
            '<div class="item-inner">' +
            '<div class="item-title" style="white-space: normal; color:black;">' + data[soru - 1].choice_a + '</div>' +
            '</div>' +
            '</a>' +
            '</li>' +
            '<li>' +
            '<a href="#" class="item-link item-content questionChoice" choise="2" soru-id="' + soru + '">' +
            '<div class="item-media">B)</div>' +
            '<div class="item-inner">' +
            '<div class="item-title" style="white-space: normal; color:black;">' + data[soru - 1].choice_b + '</div>' +
            '</div>' +
            '</a>' +
            '</li>' +
            '<li>' +
            '<a href="#" class="item-link item-content questionChoice" choise="3" soru-id="' + soru + '">' +
            '<div class="item-media">C)</div>' +
            '<div class="item-inner">' +
            '<div class="item-title" style="white-space: normal; color:black;">' + data[soru - 1].choice_c + '</div>' +
            '</div>' +
            '</a>' +
            '</li>' +
            '<li>' +
            '<a href="#" class="item-link item-content questionChoice" choise="4" soru-id="' + soru + '">' +
            '<div class="item-media">D)</div>' +
            '<div class="item-inner">' +
            '<div class="item-title" style="white-space: normal; color:black;">' + data[soru - 1].choice_d + '</div>' +
            '</div>' +
            '</a>' +
            '</li>' +
            '</ul>' +
            '</div>' +
            '<div class="content-block">' +
            '<p class="answer-callback"></p>' +
            '<p class="answer-callback2"></p>' +
            '<a href="" class="button active mybutton2 questionCon" style="display: none" soru-id="' + soru + '">' + btnHtml + '</a>' +
            '</div>';
    } else {
        html = '<div class="row">' +
            '<div class="content-block">' +
            '   <p>Son soruyu cevaplamak için süreniz dolmuştur! Sıralamaya girmek için lütfen yarışmayı bitiriniz.</p>' +
            '</div>' +
            '<a href="" class="button active mybutton2 questionCon" style="display: none" soru-id="' + soru + '"> YARIŞMAYI SONLANDIR </a>' +
            '</div>';

    }


    return html;
}