// Initialize your app
var myApp = new Framework7({
    animateNavBackIcon: true,
    // Enable templates auto precompilation
    precompileTemplates: true,
    // Enabled pages rendering using Template7
    template7Pages: true,
    template7Data: {},
    onPageInit: function (page, pageData) {

        //
    }
});


// Export selectors engine
var $$ = Dom7;

// Add main View
var mainView = myApp.addView('.view-main', {
    // Enable dynamic Navbar
    dynamicNavbar: true

});


//////////////////////////////////////////////////////
// kv
var kivaAccountName = "kvacc5371";
var activeID = null;
var mobileAppId = 2;
var website = 'http://educaturk-demo.kivayazilim.com/';
var mainMenuDepth = 0;
var popupOpen = 0;
var myPhotoBrowserPopup = '';
var androidStoreAppId = "com.boyutgroup.educaturk";
var iosStoreAppId = "1147694001";
var getConfigReload = false;

var hardBackButton = 0; // hardback 0 ise hardback tuşunun işlevinin çalışması için koyulmuştur. QR Code Okuyucu gibi kısımlar açıldıgında bu değişken 1 yapılıp uygulamadan cıkış yapmadan sadece qr code içinden cıkmak için kontrol sağlar.
var activeConversation = null;


var KV = {
        // Auth Control

        IOSversionNumber: "2.0.1",
        AndroidversionNumber: "2.0.4",
        activeEvent: null,
        push: null,
        pushMenu: null,

        activeExtended: null,
        getAccessToken: function (force, onComplete) {
            force = force || false;

            if (!force && sessionStorage.accessToken) {
                kvapi.setAccessToken(sessionStorage.accessToken);
            } else {
                // get your access token from your server
                $$.ajax({
                        url: website + 'mobil/apiTicket.php',
                        data: {},
                        complete: function (response) {
                            var r = JSON.parse(response.responseText);
                            sessionStorage.accessToken = r.access_token;

                            kvapi.setAccessToken(sessionStorage.accessToken);

                            if (typeof(onComplete) == "function") onComplete();
                        },
                        error: function (XMLHttpRequest, textStatus, errorThrown) {
                            console.log(textStatus)
                            if (!textStatus) {
                                myApp.alert("İnternet Bağlantınızı Kontrol Ediniz.", "Bilgi", function () {
                                    KV.getAccessToken(force, onComplete);
                                })
                            }
                        }

                    }
                );
            }
        },
        getConfig: function () {

            // localStorage.clear();
            // sessionStorage.clear();
            myApp.showIndicator();

            KV.getAccessToken();

            // MOBILE DEVICE SOR
            if (deviceID) {
                console.log(deviceID);

                // Önce uygulamanın bağlı olduğu event çekilmeli, her event için farklı kayıt olunması gerekiyor.

                kvapi.get("/data/cms/mobile_app", {
                    viewId: "all",
                    filters: JSON.stringify({
                        "cms_mobile_app_id": ["=", mobileAppId]
                    })
                }).then(function (cb) {
                    KV.userPolicy = (cb.response.records[0].usage_policy_url);
                    KV.activeEvent = cb.response.records[0].event_name.value;
                    KV.poll_type_menu = (cb.response.records[0].poll_type_menu) ? true : false;
                    KV.order_poll = (cb.response.records[0].order_poll) ? true : false;
                    var filter = {"device_id": ["=", deviceID], "event_name": ["=", KV.activeEvent]};
                    kvapi.get("/data/cms/mobile_device", {
                        viewId: "mobile_app",
                        filters: JSON.stringify(filter)
                    })
                        .then(function (response) {
                            console.log(response);
                            myApp.hideIndicator();
                            if (response.response.total < 1) {
                                mainView.router.load({
                                    reload: true,
                                    url: 'loginType.html',
                                    context: ''
                                });
                            }
                            else {

                                // Katılımcılar için e posta onayına bakılmayaacaği için if-else yorum satırına alındı
                                // if (!response.response.records[0].active && response.response.records[0].relatedData.registration.show_only_users.value == 6) {
                                //     var dialog = myApp.modal({
                                //         title: 'E-Posta Onayı!',
                                //         text: 'Kaydınız alınmıştır, Uygulamaya giriş yapabilmek için e-posta adresinize gelen linki onaylayınız.',
                                //         buttons: [
                                //             {
                                //                 text: 'Onayladım',
                                //                 onClick: function () {
                                //                     myApp.closeModal(dialog);
                                //                     KV.getConfig();
                                //                 }
                                //             }
                                //
                                //         ]
                                //     });
                                //
                                // }
                                // else {
                                activeID = response.response.records[0].registration.value;

                                kvapi.get("/data/event/registration", {
                                    viewId: "mobile_app",
                                    filters: JSON.stringify({
                                        "event_registration_id": ["=", activeID]
                                    })
                                })
                                    .then(function (cb) {

                                        var allUserData = cb.response.records[0];
                                        var userData = {
                                            "userID": activeID,
                                            "deviceRecordID": response.response.records[0].record_id,
                                            "userName": response.response.records[0].relatedData.registration.firstname + ' ' + response.response.records[0].relatedData.registration.lastname,
                                            "allUserData": allUserData
                                        };
                                        localStorage.setItem("userData", JSON.stringify(userData));

                                        if (!localStorage.userData) {

                                            KV.getAccessToken();
                                            kvapi.get("/data/cms/mobile_app", {
                                                viewId: "all",
                                                filters: JSON.stringify({
                                                    "cms_mobile_app_id": ["=", mobileAppId]
                                                })
                                            }).then(function (cb) {
                                                KV.userPolicy = (cb.response.records[0].usage_policy_url);
                                                mainView.router.load({
                                                    reload: true,
                                                    url: 'loginType.html',
                                                    context: '',
                                                });
                                            }).catch(function (cb) {
                                                console.log(cb);
                                            });
                                        }
                                        else {
                                            KV.getAccessToken();
                                            var show_only_users = JSON.parse((localStorage.getItem("userData"))).allUserData.show_only_users.value;


                                            // init PUSH
                                            try {
                                                if (KV.push == null) {
                                                    KV.push = PushNotification.init({
                                                        android: {
                                                            senderID: "129613237013",
                                                            sound: true,
                                                            vibrate: true,
                                                            topics: ['all', 'android', 'userType' + show_only_users]
                                                        },
                                                        ios: {
                                                            alert: true,
                                                            badge: true,
                                                            clearBadge: true,
                                                            sound: true,
                                                            senderID: "129613237013",
                                                            gcmSandbox: false,
                                                            topics: ['all', 'ios', 'userType' + show_only_users]
                                                        },
                                                        windows: {}
                                                    });

                                                    KV.push.on('error', function (e) {
                                                        console.log(e)
                                                    });

                                                    KV.push.on('registration', function (data) {
                                                        //console.log(data);

                                                        var oldRegId = localStorage.getItem('pushRegistrationId');
                                                        if (oldRegId !== data.registrationId) {
                                                            // Save new registration ID
                                                            localStorage.setItem('pushRegistrationId', data.registrationId);
                                                            // Post registrationId to your app server as the value has changed
                                                            kvapi.post("/data/cms/mobile_device", {
                                                                upsert: true,
                                                                upsertFields: ["push_token"],
                                                                records: [
                                                                    {
                                                                        device_id: deviceID,
                                                                        push_token: data.registrationId
                                                                    }
                                                                ]
                                                            })
                                                                .then(function (response) {
                                                                    console.log("Device RegistrationId Changed");
                                                                });
                                                        }
                                                    });

                                                    KV.push.on('notification', function (data) {
                                                        //console.log(data);
                                                        KV.push.setApplicationIconBadgeNumber(function () {
                                                            //console.log('success');
                                                        }, function () {
                                                            //console.log('error');
                                                        }, 0);
                                                        //console.log("type", data.additionalData.notification_type);

                                                        // myApp.alert(data.message, data.title, function () {
                                                        //     if (data.additionalData != undefined) {
                                                        //         if (data.additionalData.route != undefined) {
                                                        //             KV.getStaticPage(data.additionalData.route);
                                                        //         }
                                                        //     }
                                                        // });
                                                        if (data.additionalData.notification_type == 1) {
                                                            var item = KV.menu[data.additionalData.menu];
                                                            if (item) {
                                                                if (item.sub) {
                                                                    myApp.modal({
                                                                        title: data.title,
                                                                        text: data.message,
                                                                        buttons: [
                                                                            {
                                                                                text: 'Aç',
                                                                                onClick: function () {
                                                                                    if (data.additionalData != undefined) {
                                                                                        if (data.additionalData.menu != undefined) {
                                                                                            KV.activeExtended = data.additionalData.menu;
                                                                                            var pageType = (item.pageType) ? item.pageType : null;
                                                                                            KV.initMenu(item.sub, pageType, '', data.additionalData.menu, true);
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            {
                                                                                text: 'Kapat',
                                                                                onClick: function () {
                                                                                }
                                                                            }
                                                                        ]
                                                                    });


                                                                    // myApp.alert(data.message, data.title, function () {
                                                                    //     if (data.additionalData != undefined) {
                                                                    //         if (data.additionalData.menu != undefined) {
                                                                    //             KV.activeExtended = data.additionalData.menu;
                                                                    //             var pageType = (item.pageType) ? item.pageType : null;
                                                                    //             KV.initMenu(item.sub, pageType, '', data.additionalData.menu, true);
                                                                    //         }
                                                                    //     }
                                                                    // });
                                                                }
                                                            }
                                                        }
                                                        if (data.additionalData.notification_type == 2) {
                                                            myApp.modal({
                                                                title: data.title,
                                                                text: data.message,
                                                                buttons: [
                                                                    {
                                                                        text: 'Aç',
                                                                        onClick: function () {
                                                                            if (data.additionalData != undefined) {
                                                                                console.log(data);
                                                                                if (data.additionalData != undefined) {
                                                                                    //console.log("test");
                                                                                    if (data.additionalData.page != undefined) {
                                                                                        //console.log("asdad");
                                                                                        //console.log(data);
                                                                                        KV.getStaticPage(data.additionalData.page);
                                                                                    }
                                                                                }
                                                                            }
                                                                        }
                                                                    },
                                                                    {
                                                                        text: 'Kapat',
                                                                        onClick: function () {
                                                                        }
                                                                    }
                                                                ]
                                                            });
                                                            // myApp.alert(data.message, data.title, function () {
                                                            //     console.log(data);
                                                            //     if (data.additionalData != undefined) {
                                                            //         //console.log("test");
                                                            //         if (data.additionalData.page != undefined) {
                                                            //             //console.log("asdad");
                                                            //             //console.log(data);
                                                            //             KV.getStaticPage(data.additionalData.page);
                                                            //         }
                                                            //     }
                                                            // });
                                                        }
                                                        if (data.additionalData.notification_type == 3) {
                                                            myApp.modal({
                                                                title: data.title,
                                                                text: data.message,
                                                                buttons: [
                                                                    {
                                                                        text: 'Aç',
                                                                        onClick: function () {
                                                                            KV.openPoll(null, {empty_text: "Henüz anket bulunmamaktadır."});

                                                                        }
                                                                    },
                                                                    {
                                                                        text: 'Kapat',
                                                                        onClick: function () {
                                                                        }
                                                                    }
                                                                ]
                                                            });
                                                            //KV.openPoll(null, {empty_text: "Henüz anket bulunmamaktadır."});
                                                        }
                                                        if (data.additionalData.notification_type == 4) {
                                                            var now = new Date();
                                                            now.addHours(3);
                                                            var iso = now.toISOString().match(/(\d{4}\-\d{2}\-\d{2})T(\d{2}:\d{2}:\d{2})/);
                                                            var filterDate = iso[1] + ' ' + iso[2];
                                                            var filters = {
                                                                "end_time": [">", filterDate],
                                                                "start_time": ["<", filterDate],
                                                                "active": ["=", "1"],
                                                                "registration": ["EMPTY OR IN", [activeID]],
                                                                "event_news_id": ["=", data.additionalData.news]
                                                            };
                                                            //console.log(filters);
                                                            kvapi.get("/data/event/news", {
                                                                viewId: "mobile_app",
                                                                filters: JSON.stringify(filters)
                                                            }).then(function (res) {
                                                                //console.log(res);
                                                                if (res.response.total) {

                                                                    myApp.modal({
                                                                        title: data.title,
                                                                        text: data.message,
                                                                        buttons: [
                                                                            {
                                                                                text: 'Aç',
                                                                                onClick: function () {
                                                                                    if (data.additionalData != undefined) {
                                                                                        //console.log("test");
                                                                                        if (data.additionalData.news != undefined) {
                                                                                            newsData = res.response.records[0];
                                                                                            newsData.upData = "";
                                                                                            newsData.back = "main.html";
                                                                                            myApp.template7Data['page:newsDetail'] = newsData;
                                                                                            mainView.router.load({
                                                                                                url: 'newsDetail.html'
                                                                                            });
                                                                                        }
                                                                                    }
                                                                                }
                                                                            },
                                                                            {
                                                                                text: 'Kapat',
                                                                                onClick: function () {
                                                                                }
                                                                            }
                                                                        ]
                                                                    });
                                                                    // myApp.alert(data.message, data.title, function () {
                                                                    //     //console.log(data);
                                                                    //     if (data.additionalData != undefined) {
                                                                    //         //console.log("test");
                                                                    //         if (data.additionalData.news != undefined) {
                                                                    //             newsData = res.response.records[0];
                                                                    //             newsData.upData = "";
                                                                    //             newsData.back = "main.html";
                                                                    //             myApp.template7Data['page:newsDetail'] = newsData;
                                                                    //             mainView.router.load({
                                                                    //                 url: 'newsDetail.html'
                                                                    //             });
                                                                    //         }
                                                                    //     }
                                                                    // });
                                                                }
                                                            });
                                                        }
                                                        if (data.additionalData.notification_type == 5) {
                                                            myApp.modal({
                                                                title: data.title,
                                                                text: data.message,
                                                                buttons: [

                                                                    {
                                                                        text: 'Kapat',
                                                                        onClick: function () {
                                                                        }
                                                                    }
                                                                ]
                                                            });
                                                            //myApp.alert(data.message, data.title);
                                                        }
                                                        if (data.additionalData.notification_type == 6) {
                                                            if (data.additionalData.conversation != undefined) {

                                                                //console.log(data.additionalData.conversation.conversation_label);
                                                                //console.log(activeConversation);

                                                                if (typeof data.additionalData.conversation == "string") {
                                                                    data.additionalData.conversation = JSON.parse(data.additionalData.conversation);
                                                                    //console.log("Conversation: ", data.additionalData.conversation);
                                                                }

                                                                if (activeConversation == data.additionalData.conversation.conversation_label && activeConversation) {
                                                                    var msgTime = new Date();
                                                                    var msg = {
                                                                        id: 0,
                                                                        text: data.additionalData.conversation.message,
                                                                        type: "received",
                                                                        day: "Bugün",
                                                                        time: (new Date()).toTimeString().split(' ')[0]
                                                                    };
                                                                    myApp.messages(".messages").appendMessage(msg);
                                                                    return;
                                                                }

                                                                myApp.modal({
                                                                    title: data.title,
                                                                    text: data.message,
                                                                    buttons: [
                                                                        {
                                                                            text: 'Aç',
                                                                            onClick: function () {
                                                                                var conversationParams = data.additionalData.conversation;
                                                                                conversationParams.toBack = 'main.html';
                                                                                KV.toConverstaion(conversationParams);
                                                                            }
                                                                        },
                                                                        {
                                                                            text: 'Kapat',
                                                                            onClick: function () {
                                                                            }
                                                                        }
                                                                    ]
                                                                });
                                                            }
                                                        }
                                                    });
                                                }
                                            } catch (err) {
                                                console.log(err)
                                            }

                                            var html = '';
                                            myApp.showIndicator();
                                            $$.ajax({
                                                    url: "http://educaturk-demo.kivayazilim.com/mobilconf/" + mobileAppId + '/' + show_only_users,
                                                    dataType: "jsonp",
                                                    jsonpCallback: "callback",
                                                    data: {deneme: "deneme"},
                                                    error: function () {
                                                        myApp.hideIndicator();
                                                        myApp.modal({
                                                            title: 'Error',
                                                            text: 'Uygulama datası yüklenemedi.',
                                                            buttons: [
                                                                {
                                                                    text: 'Yeniden Yükle',
                                                                    onClick: function () {
                                                                        KV.getConfig();
                                                                    }
                                                                },
                                                                {
                                                                    text: 'İptal',
                                                                    onClick: function () {

                                                                    }
                                                                }
                                                            ]
                                                        })
                                                    },
                                                    success: function (response) {

                                                        var rs = JSON.parse(response);

                                                        console.log(rs.menu);
                                                        $$('#appName').attr('src', website + rs.header_logo);
                                                        $$('.toolbar-bottom').css("z-index", "999");
                                                        if (rs.banner) {
                                                            KV.doBanner(rs.banner.image_url, rs.banner.link, true);
                                                        }
                                                        $$('.navbar').css("z-index", "999");
                                                        $$('#userName').html(JSON.parse((localStorage.getItem("userData"))).userName);

                                                        var menu = rs.menu;
                                                        var menuArrayTemp = [];

                                                        console.log(JSON.parse((localStorage.getItem("userData"))));
                                                        var isContactPerson = JSON.parse(localStorage.getItem("userData")).allUserData.contact_exhibitor_person;
                                                        var isExh = (JSON.parse(localStorage.getItem("userData")).allUserData.show_only_users.value == 6) ? 1 : 0;

                                                        KV.menu = [];
                                                        $$.each(menu, function (index, value) {
                                                            if (value.only_contact_exhibitor_person && isExh) {
                                                                if (isContactPerson) {
                                                                    menuArrayTemp.push(value);
                                                                }
                                                            } else {
                                                                menuArrayTemp.push(value);
                                                            }
                                                            KV.menu[value.record_id] = value;
                                                            if (value.sub) {
                                                                $$.each(value.sub, function (index2, value2) {
                                                                    KV.menu[value2.record_id] = value2;
                                                                    if (value2.sub) {
                                                                        $$.each(value2.sub, function (index3, value3) {
                                                                            KV.menu[value3.record_id] = value3;
                                                                        })
                                                                    }
                                                                })
                                                            }
                                                        });

                                                        KV.setLeftPanel(menu);
                                                        KV.mainMenu = menuArrayTemp;
                                                        //KV.initMenu(menuArrayTemp);

                                                        // Version Kontrol
                                                        kvapi.get("/data/cms/mobile_app_version", {
                                                            viewId: "all",
                                                            filters: JSON.stringify({
                                                                "mobile_app": ["=", mobileAppId],
                                                                "platform": ["=", (myApp.device.os == "android") ? 2 : 1]
                                                            }),
                                                            sort: "version_number DESC",
                                                            start: 0,
                                                            limit: 1
                                                        })
                                                            .then(function (cb) {
                                                                //myApp.hideIndicator();
                                                                var versionNumber = (myApp.device.os == "android") ? KV.AndroidversionNumber : KV.IOSversionNumber;

                                                                console.log("Installed Version: " + versionNumber);
                                                                console.log("Lastest Version: " + cb.response.records[0].version_number);

                                                                if (cb.response.records[0].version_number > versionNumber) {
                                                                    myApp.modal({
                                                                        "title": "Yeni Versiyon!",
                                                                        "text": "Educaturk Mobil Uygulamasını tüm özellikleri ile kullanmak için lütfen güncelleyin.",
                                                                        "buttons": [{
                                                                            "text": "Güncel Versiyonu Yükle"
                                                                        }],
                                                                        "onClick": function () {
                                                                            if (myApp.device.os == "android") {
                                                                                window.location = "market://details?id=" + androidStoreAppId;
                                                                            } else if (myApp.device.os == "ios") {
                                                                                var link = "itms-apps://itunes.apple.com/app/id" + iosStoreAppId;
                                                                                cordova.InAppBrowser.open(link, "_system", "location=yes")
                                                                            }
                                                                        }
                                                                    });
                                                                } else {

                                                                }
                                                            });


                                                        // if (KV.pushMenu) {
                                                        //     var data = KV.pushMenu;
                                                        //     KV.pushMenu = null;
                                                        //     // Menü için bu kısım alınacak
                                                        //     var item = KV.menu[data.additionalData.menu];
                                                        //     if (item) {
                                                        //         if (item.sub) {
                                                        //             myApp.alert(data.message, data.title, function () {
                                                        //                 if (data.additionalData != undefined) {
                                                        //                     if (data.additionalData.menu != undefined) {
                                                        //                         KV.activeExtended = data.additionalData.menu;
                                                        //                         var pageType = (item.pageType) ? item.pageType : null;
                                                        //                         KV.initMenu(item.sub, pageType, '', data.additionalData.menu, true);
                                                        //                     }
                                                        //                 }
                                                        //             });
                                                        //         }
                                                        //     }
                                                        //     // /Menü için bu kısım alınacak
                                                        // } else {
                                                        KV.initMenu(menuArrayTemp);
                                                        //}
                                                    }
                                                }
                                            )
                                            ;


                                        }
                                        //myApp.hideIndicator();

                                    }).catch(function () {

                                })
                                // }
                            }
                        })
                        .catch(function (response) {
                            //console.log("catch_");
                        });

                }).catch(function (cb) {
                    console.log(cb);
                });

            } else {
                myApp.alert("Uygulamayı Mobil Cihaz ile denemelisiniz.", "UYARI");
            }


        },

        doBanner: function (banner, banner_link, doGlobal) {
            var adBannerHtml = '<img src="' + banner + '" id="adBanner" style="width: 100%; height: 100%">';
            if (banner_link) {
                adBannerHtml = '<a href="' + banner_link + '"  class="external" target="_system">' + adBannerHtml + '</a>';
            }
            if (doGlobal) {
                KV.gloabalBannerHtml = adBannerHtml;
            }
            $$('#adBanner').html(adBannerHtml);
        },

        getStaticPage: function (route, pageType, upPageType) {
            console.log(route);
            activeConversation = null;
            myApp.showIndicator();
            $$.ajax({
                url: "http://educaturk-demo.kivayazilim.com" + route,
                dataType: "jsonp",
                jsonpCallback: "callback",
                data: {fromMobile: true},
                error: function () {
                    myApp.hideIndicator();
                    myApp.modal({
                        title: 'Error',
                        text: 'Uygulama datası yüklenemedi.',
                        buttons: [
                            {
                                text: 'Yeniden Yükle',
                                onClick: function () {
                                    KV.getStaticPage(route);
                                }
                            },
                            {
                                text: 'İptal',
                                onClick: function () {

                                }
                            }
                        ]
                    })
                },
                success: function (response) {

                    //myApp.hideIndicator();
                    var rs = JSON.parse(response);
                    rs.upPageType = (upPageType == 'mainExtended') ? true : false;
                    console.log(rs);


                    var adBanner = KV.gloabalBannerHtml;
                    var bannerLink = '#';
                    pageType = rs.pageType;
                    if (pageType == 'static') {
                        if (rs.banner) {
                            KV.doBanner(rs.banner, rs.banner_link, false);
                        } else {
                            $$('#adBanner').html(KV.gloabalBannerHtml);
                        }
                        // if (typeof rs.banner !== "undefined") {
                        // //     console.log(rs.banner_link);
                        // //     adBannerHtml = '<img src="' + rs.banner + '" id="adBanner" style="width: 100%; height: 100%">';
                        // //     if (typeof rs.banner_link !== "undefined") {
                        // //         adBannerHtml = '<a href="' + rs.banner_link + '"  class="external" target="_system">' + adBannerHtml + '</a>';
                        // //     }
                        // //     $$('#adBanner').html(adBannerHtml);
                        // // } else {
                        // //     $$('#adBanner').html(KV.gloabalBannerHtml);
                        // }
                        //$$('#adBanner').show();

                        if (typeof rs.page_content_tr === "undefined") {
                            rs.page_content_tr = rs.empty_text;
                        }
                        myApp.template7Data['page:static'] = rs;
                        mainView.router.load({
                            reload: true,
                            url: 'static.html',
                        });
                        myApp.hideIndicator();
                    } else {
                        // if (typeof rs.dynamicPageType.banner !== "undefined") {
                        //     adBannerHtml = '<img src="' + rs.dynamicPageType.banner + '" id="adBanner" style="width: 100%; height: 100%">';
                        //     if (typeof rs.dynamicPageType.banner_link !== "undefined") {
                        //         adBannerHtml = '<a href="' + rs.dynamicPageType.banner_link + '"  class="external" target="_system">' + adBannerHtml + '</a>';
                        //     }
                        //     $$('#adBanner').html(adBannerHtml);
                        // } else {
                        //     $$('#adBanner').html(KV.gloabalBannerHtml);
                        // }
                        //
                        // $$('#adBanner').show();
                        if (rs.dynamicPageType.banner) {
                            KV.doBanner(rs.dynamicPageType.banner, rs.dynamicPageType.banner_link, false);
                        } else {
                            $$('#adBanner').html(KV.gloabalBannerHtml);
                        }

                        var pg = null;
                        if (typeof rs.dynamicPageType.empty_text === "undefined") {
                            rs.dynamicPageType.empty_text = "";
                        }
                        switch (rs.dynamicPageType.dynamic_page_type.value) {
                            case 16:
                                //myApp.showIndicator();
                                KV.openQrCodeReader();
                                return;
                                break;
                            case 17:
                                pg = "qrContactList";
                                var filter = {"registration": ["=", activeID]};
                                var dir = "ASC";
                                var sort_order = "fullname";
                                kvapi.get("/data/networking/contact_list", {
                                    viewId: "mobile_app",
                                    filters: JSON.stringify(filter),
                                    sort: sort_order,
                                    dir: dir

                                })
                                    .then(function (response) {
                                        var data = response.response.records;
                                        console.log(data);

                                        var x = {};
                                        for (var i = 0; i < data.length; ++i) {
                                            var obj = data[i];
                                            //If a property for this FULLNAME FIRST LETTER does not exist yet, create
                                            var key = KV.trkToUppercase(obj.fullname.charAt(0));
                                            obj.key = key;
                                            if (x[key] === undefined)
                                                x[key] = []; //Assign a new array with the first element of FULLNAME FIRST LETTER.
                                            //x will always be the array corresponding to the current FULLNAME FIRST LETTER. Push a value the current value to it.
                                            x[key].push(obj);
                                        }
                                        rs.qrContactList = x;
                                        rs.qrContactListLength = (Object.keys(x).length);
                                        rs.empty_text = rs.dynamicPageType.empty_text;
                                        KV.qrContactList = rs.qrContactList;
                                        console.log(rs);

                                        KV.dynamicRoute(pg, rs);
                                    })

                                break;
                            case 18: {
                                pg = "quiz";
                                console.log(route);

                                var show_only_users = JSON.parse((localStorage.getItem("userData"))).allUserData.show_only_users.value;
                                console.log(show_only_users);
                                // var u = JSON.parse((localStorage.getItem("userData"))).allUserData;
                                // var ctrl = 0;
                                //
                                // if ([2, 3, 5, 6].indexOf(show_only_users) != -1) {
                                //     if (!u.firstname || !u.lastname || !u.email || !u.relatedData.part_contact.phone || !u.relatedData.part_contact.date_of_birth || !u.contact_preferences || !u.address_city) {
                                //         ctrl = 1;
                                //     }
                                // }
                                //
                                // if ([2, 5, 6].indexOf(show_only_users) != -1) {
                                //     if (!u.title) {
                                //         ctrl = 1;
                                //     }
                                // }
                                //
                                // if ([2, 3, 6].indexOf(show_only_users) != -1) {
                                //     if (!u.relatedData.part_contact.gender) {
                                //         ctrl = 1;
                                //     }
                                // }
                                //
                                // if ([2, 3].indexOf(show_only_users) != -1) {
                                //     if (!u.organization_non_exhibitor) {
                                //         ctrl = 1;
                                //     }
                                // }
                                //
                                // if ([2, 5].indexOf(show_only_users) != -1) {
                                //     console.log(show_only_users);
                                //     if (!u.grad_uni) {
                                //         ctrl = 1;
                                //     }
                                // }
                                //
                                // if (show_only_users == 3) {
                                //     if (!u.classroom || !u.student_department) {
                                //         ctrl = 1;
                                //     }
                                // }
                                //
                                // if (show_only_users == 6) {
                                //     if (!u.organization) {
                                //         ctrl = 1;
                                //     }
                                // }


                                /*var controlUserData = (JSON.parse((localStorage.getItem("userData"))).allUserData);
                                 var ctrl = 0;

                                 if ((controlUserData.show_only_users.value == 2 || controlUserData.show_only_users.value == 3) && !controlUserData.organization_non_exhibitor) {
                                 ctrl = 1;
                                 }

                                 if (controlUserData.show_only_users.value == 2 && (!controlUserData.relatedData.part_contact.title)) {
                                 ctrl = 1;
                                 }

                                 if (controlUserData.show_only_users.value == 3 && (!controlUserData.classroom || !controlUserData.student_department)) {
                                 ctrl = 1;
                                 }

                                 if (controlUserData.show_only_users.value == 6 && (!controlUserData.organization || !controlUserData.exhibitor_req_city || !controlUserData.relatedData.part_contact.title)) {
                                 ctrl = 1;
                                 }

                                 if (!controlUserData.firstname || !controlUserData.lastname || !controlUserData.email || !controlUserData.relatedData.part_contact.phone || !controlUserData.relatedData.part_contact.date_of_birth || !controlUserData.relatedData.part_contact.gender || !controlUserData.address_city || !controlUserData.contact_preferences
                                 ) {
                                 ctrl = 1;
                                 }**/
                                var pqRs = {
                                    routeOrigin: route,
                                    pageType: pageType,
                                    upPageType: upPageType
                                };
                                var wTitle = "Yarışma ve fırsatlardan yararlanmak için profilinizi tamamlayınız.";
                                var s = KV.warningCompleteProfile(pqRs, wTitle);
                                if (!s) {
                                    // var dialog = myApp.modal({
                                    //     title: 'Dikkat!',
                                    //     text: 'Yarışma ve fırsatlardan yararlanmak için profilinizi tamamlayınız.',
                                    //     buttons: [
                                    //         {
                                    //             text: 'Vazgeç',
                                    //             onClick: function () {
                                    //                 myApp.closeModal(dialog);
                                    //             }
                                    //         },
                                    //         {
                                    //             text: 'Profili Tamamla',
                                    //             onClick: function () {
                                    //                 // data = {
                                    //                 //     pageTitle: "PROFİLİM",
                                    //                 //     userData: controlUserData,
                                    //                 //     return: {route: route, pageType: pageType, upPageType: upPageType}
                                    //                 // }
                                    //                 // KV.dynamicRoute("profile", data);
                                    //                 KV.openProfilePage(null, {
                                    //                     route: route,
                                    //                     pageType: pageType,
                                    //                     upPageType: upPageType
                                    //                 })
                                    //             }
                                    //         },
                                    //
                                    //     ]
                                    // });
                                }


                                else {

                                    var tzoffset = (new Date()).getTimezoneOffset() * 60000; //offset in milliseconds
                                    var localISOTime = (new Date(Date.now() - tzoffset)).toISOString().slice(0, -1);
                                    console.log(localISOTime);
                                    // alert(localISOTime);

                                    var now = new Date();
                                    console.log(now)
                                    var iso = now.toISOString().match(/(\d{4}\-\d{2}\-\d{2})T(\d{2}:\d{2}:\d{2})/)
                                    var filterDate = iso[1] + ' ' + iso[2]
                                    console.log(filterDate);
                                    var show_only_users = JSON.parse((localStorage.getItem("userData"))).allUserData.show_only_users.value;
                                    myApp.showIndicator();
                                    kvapi.get("/data/game/quiz", {
                                        viewId: "mobile_app",
                                        filters: JSON.stringify({
                                            "start_date": ["<", localISOTime],
                                            // "start_date": ["<", filterDate],
                                            "end_date": [">", localISOTime],
                                            // "end_date": [">", filterDate],
                                            "active": ["=", "1"]
                                        }),
                                    }).then(function (cb) {
                                        //console.log(cb.response.records);
                                        var records = [];
                                        $$.each(cb.response.records, function (index, value) {
                                            value.start_date = KV.setDate(value.start_date);
                                            value.end_date = KV.setDate(value.end_date);
                                            if (!value.show_only_users) {
                                                records.push(value);
                                            } else {
                                                $$.each(value.show_only_users, function (sindex, svalue) {
                                                    if (svalue.value == 1 || svalue.value == show_only_users) {
                                                        records.push(value);
                                                    }
                                                });
                                            }
                                        });
                                        KV.dynamicRoute(pg, {records: records, empty_text: rs.dynamicPageType.empty_text});
                                    }).catch(function (rs) {
                                        myApp.hideIndicator();
                                        KV.alertFail();
                                    });
                                }
                                break;
                            }
                            case 19: {
                                var qrData = JSON.parse((localStorage.getItem("userData")))[rs.dynamicPageType.qr_code_data]

                                if (!qrData) {
                                    //console.log("qrdata yok")
                                } else {
                                    //console.log("qrdata var")
                                }
                                //return false;
                                pg = "createQr";
                                kvapi.get("/data/event/registration/" + activeID + "/template/" + rs.dynamicPageType.qr_code_data, {
                                    viewId: "all"
                                }).then(function (cb) {

                                    rs.qrCode = {file: cb.response.content};
                                    KV.dynamicRoute(pg, rs);
                                }).catch(function (rs) {
                                    printResponse(rs);
                                });
                                break;
                                /*qrData = KV.getQrData(rs.dynamicPageType.qr_code_data);

                                 cordova.plugins.barcodeScanner.encode(cordova.plugins.barcodeScanner.Encode.TEXT_TYPE, qrData, function (success) {


                                 var qrCodeImg = success.file + '?r=' + Math.random();

                                 rs.qrCode = {file: qrCodeImg};
                                 KV.dynamicRoute(pg, rs);


                                 }, function (fail) {
                                 alert("encoding failed: " + fail);
                                 myApp.alert("QR kod oluşturulamadı.", "Hata!")
                                 }
                                 );*/

                                break;
                            }
                            case 20: {
                                pg = "calendar2.html";
                                kvapi.get("/data/cms/calendar_entry", {
                                    viewId: "mobile_app",
                                    filters: JSON.stringify({
                                        "dynamic_page": ["=", rs.dynamicPageType.record_id]
                                    })
                                }).then(function (cb) {
                                    console.log(cb.response.records);
                                    //console.log(rs);
                                    var data = {
                                        events: cb.response.records,
                                        pageTitle: rs.pageTitle,
                                        empty_text: rs.dynamicPageType.empty_text
                                    };
                                    // console.log(data);

                                    myApp.hideIndicator();
                                    mainView.router.load({
                                        reload: true,
                                        url: pg,
                                        context: data
                                    });

                                }).catch(function (rs) {
                                    console.log(rs);
                                });

                                break;
                            }
                            case 21: {

                                KV.openPoll(null, rs);
                                return false;
                                var now = new Date();
                                var iso = now.toISOString().match(/(\d{4}\-\d{2}\-\d{2})T(\d{2}:\d{2}:\d{2})/)
                                var filterDate = iso[1] + ' ' + iso[2];
                                pg = "poll.html";

                                var records = [];
                                kvapi.get("/data/event/poll", {
                                    viewId: "mobile_app",
                                    filters: JSON.stringify({
                                        "end_time": [">", filterDate],
                                        "active": ["=", "1"],
                                        "poll_type": ["=", "1"],
                                        "registration": ["=", activeID]
                                    }),
                                    sort: "sort_order",
                                    dir: "ASC"
                                }).then(function (res) {
                                    records = res.response.records;
                                    console.log(res);
                                    $$.each(res.response.records, function (index, value) {
                                        res.response.records[index].end_time = KV.setDate(value.end_time);
                                    });
                                    kvapi.get("/data/event/poll", {
                                        viewId: "mobile_app",
                                        filters: JSON.stringify({
                                            "end_time": [">", filterDate],
                                            "active": ["=", "1"],
                                            "poll_type": ["=", "1"],
                                            "registration": ["EMPTY"]
                                        }),
                                        sort: "sort_order",
                                        dir: "ASC"
                                    }).then(function (cb) {
                                        var show_only_users = JSON.parse((localStorage.getItem("userData"))).allUserData.show_only_users.value;
                                        $$.each(cb.response.records, function (index, value) {
                                            value.end_time = KV.setDate(value.end_time);
                                            if (!value.show_only_users) {
                                                records.push(value);
                                            } else {
                                                $$.each(value.show_only_users, function (sindex, svalue) {
                                                    if (svalue.value == 1 || svalue.value == show_only_users) {
                                                        records.push(value);
                                                    }
                                                });
                                            }
                                        });
                                        myApp.template7Data['page:poll'] = {
                                            records: records,
                                            empty_text: rs.dynamicPageType.empty_text
                                        };

                                        mainView.router.load({
                                            reload: true,
                                            url: pg,
                                        });
                                    })
                                });


                                //KV.dynamicRoute(pg, rs);

                                break;
                            }
                            case 22: {

                                var pqRs = {
                                    routeOrigin: route,
                                    pageType: pageType,
                                    upPageType: upPageType
                                };


                                var wTitle = "Duyuruları görmek için profilinizi tamamlayınız.";
                                var s = KV.warningCompleteProfile(pqRs, wTitle);
                                if (s) {
                                    KV.openNews(rs);
                                }
                                break;
                            }
                            case 13: {
                                kvapi.get("/data/cms/photo", {
                                    viewId: "all",
                                    filters: JSON.stringify({
                                        "dynamic_page": ["=", rs.dynamicPageType.record_id]
                                    }),
                                    sort: "sort_order",
                                    dir: "ASC"
                                }).then(function (cb) {
                                    console.log(cb.response);
                                    if (cb.response.total > 0) {
                                        var photoGallery = [];
                                        $$.each(cb.response.records, function (index, value) {
                                            var photoData = {
                                                "record_id": value.record_id,
                                                "caption": value.label,
                                                "url": value.photo_url
                                            };
                                            photoGallery.push(photoData);
                                        });

                                        var nt = '' +
                                            '<div class="navbar"> ' +
                                            '<div class="navbar-inner"> ' +
                                            '<div class="left sliding"> ' +
                                            '<a href="#" class="link close-popup photo-browser-close-link {{#unless backLinkText}}icon-only{{/unless}} ' +
                                            '{{js "this.type === \'page\' ? \'back\' : \'\'"}}"> ' +
                                            '<i class="fa fa-chevron-left kvBack {{iconsColorClass}}"></i>' +
                                            'Geri</a> </div> <div class="center sliding"> ' +
                                            '<span style="color:black;" class="photo-browser-current {{iconsColorClass}}"></span> <span style="color:black;" class="photo-browser-of {{iconsColorClass}}">{{ofText}}</span> ' +
                                            '<span style="color:black;" class="photo-browser-total"></span> </div> <div class="right {{iconsColorClass}}"></div> </div> </div> '


                                        myPhotoBrowserPopup = myApp.photoBrowser({
                                            photos: photoGallery,
                                            type: 'popup',
                                            //theme: 'dark',
                                            lazyLoading: true,
                                            navbarTemplate: nt,
                                            swipeToClose: false,
                                            onOpen: function () {
                                                KV.openPhotoBrowser();
                                                popupOpen = 1;
                                            },
                                            onClose: function () {
                                                popupOpen = 0;
                                            }
                                        });
                                        myApp.hideIndicator();
                                        myPhotoBrowserPopup.open();
                                    } else {
                                        myApp.alert(rs.dynamicPageType.empty_text, "Bilgi");
                                    }

                                    // foreach ($photos as $photo) {
                                    // $dt = new \stdClass();
                                    // $dt->record_id = $photo->record_id;
                                    // $dt->caption = $photo->label;
                                    // $dt->url = $photo->photo_url;
                                    // $pageData->photoGallery[] = $dt;

                                }).catch(function (rs) {
                                    console.log(rs);
                                });
                                break;
                            }
                            case 25: {
                                KV.openProfilePage(rs);
                                break;
                            }
                            case 23: {
                                cordova.plugins.barcodeScanner.scan(
                                    function (result) {
                                        hardBackButton = 1;

                                        if (result.cancelled == 0 && result.text) {
                                            //$$('.page-content').append('')
                                            $$('.qrTextPopup').show();
                                            myApp.popup('.qrTextPopup');
                                            $$('#qrTextPopupText').html(result.text);
                                        }
                                    },
                                    function (error) {
                                        alert("Scanning failed: " + error);
                                    },
                                    {
                                        "preferFrontCamera": false, // iOS and Android
                                        "showFlipCameraButton": false, // iOS and Android
                                        "prompt": "Lütfen QR kodu buradan okutunuz", // supported on Android only
                                        "formats": "QR_CODE", // default: all but PDF_417 and RSS_EXPANDED
                                        "orientation": "landscape" // Android only (portrait|landscape), default unset so it rotates with the device
                                    }
                                );
                                break;
                            }
                            case 26: {
                                var page_params = JSON.parse(rs.dynamicPageType.parameters);
                                var app = page_params.app;
                                var model = page_params.model;
                                var field = page_params.display_field;
                                var event_id = rs.dynamicPageType.event_name.value;
                                console.log(event_id);
                                kvapi.get("/data/" + app + "/" + model, {
                                    viewId: 'all',
                                    //viewId: 'tum_ziyaretci_liseler',
                                    filters: JSON.stringify({
                                        "event": ["=", event_id]
                                    }),
                                    sort: field,
                                    dir: 'ASC'
                                }).then(function (cb) {
                                    var records = cb.response.records;

                                    console.log(records);
                                    recordsLength = records.length;

                                    var x = {};
                                    var y = {};
                                    for (var i = 0; i < records.length; ++i) {
                                        var obj = records[i];
                                        //If a property for this FULLNAME FIRST LETTER does not exist yet, create
                                        var key = KV.trkToUppercase(obj[field].charAt(0));
                                        obj.key = key;
                                        if (records[i].first_day) {
                                            if (x[key] === undefined)
                                                x[key] = []; //Assign a new array with the first element of FULLNAME FIRST LETTER.
                                            //x will always be the array corresponding to the current FULLNAME FIRST LETTER. Push a value the current value to it.
                                            x[key].push(obj);
                                        }
                                        if (records[i].second_day) {
                                            if (y[key] === undefined)
                                                y[key] = []; //Assign a new array with the first element of FULLNAME FIRST LETTER.
                                            //x will always be the array corresponding to the current FULLNAME FIRST LETTER. Push a value the current value to it.
                                            y[key].push(obj);
                                        }
                                    }

                                    var allRecord = [];


                                    var data = {
                                        pageTitle: rs.pageTitle,
                                        records: x,
                                        records2: y,
                                        upPageType: rs.upPageType,
                                        event_id: event_id,
                                        empty_text: rs.dynamicPageType.empty_text,
                                        recordsLength: recordsLength
                                    };
                                    var pg = 'ziyaretciLiseler';
                                    KV.dynamicRoute(pg, data);
                                }).catch(function () {

                                })

                                break;
                            }
                            case 27: {

                                KV.openExhibitors(rs, [], 0);


                                break;
                            }
                            case 29: // external page
                            // window.open(rs.dynamicPageType.static_content_tr, "_system");
                            // break;
                            case 33: {
                                console.log("XXX");
                                var pqRs = {
                                    routeOrigin: route,
                                    pageType: pageType,
                                    upPageType: upPageType
                                };
                                var wTitle = "Soru sorabilmek için profilinizi tamamlayınız.";
                                var s = KV.warningCompleteProfile(pqRs, wTitle);
                                if (!s) {
                                    return false;
                                }
                                pg = "contactExhibitors";
                                myApp.showIndicator();
                                kvapi.get("/data/event/registration", {
                                    viewId: "mobile_app",
                                    filters: JSON.stringify({
                                        "contact_exhibitor_person": ["=", 1],
                                        "show_only_users": ["=", "6"],
                                        "organization": ["NOT EMPTY"]
                                    }),
                                    sort: "sort_order",
                                    dir: "ASC"
                                }).then(function (res) {
                                    if (!res) {
                                        myApp.alert("Bir hata oluştu. Lütfen yetkiliyle görüşünüz.", "Hata");
                                        return false;
                                    }

                                    if (res.response.total < 1) {
                                        myApp.alert("Henüz aktif edilmemiştir.", "Bilgi");
                                        return false;
                                    }
                                    var records = KV.sortByLabel(res.response.records, 'organization');
                                    data = {
                                        pageTitle: rs.pageTitle,
                                        records: records,
                                        empty_text: rs.dynamicPageType.empty_text,
                                        recordsLength: (Object.keys(records).length)
                                    };
                                    KV.dynamicRoute(pg, data)
                                }).catch(function (res) {
                                    console.log(res);
                                });

                                break;
                            }
                            case 34: //Message Box For Contact Person
                            {
                                // var pqRs = {
                                //     routeOrigin: route,
                                //     pageType: pageType,
                                //     upPageType: upPageType
                                // };
                                // var wTitle = "Yarışma ve fırsatlardan yararlanmak için profilinizi tamamlayınız.";
                                // var s = KV.warningCompleteProfile(pqRs, wTitle);
                                // if (!s) {
                                //     return false;
                                // }
                                var pqRs = {
                                    routeOrigin: route,
                                    pageType: pageType,
                                    upPageType: upPageType
                                };
                                var wTitle = "Mesajlarınızı görüntülemek için profilinizi tamamlayınız.";
                                var s = KV.warningCompleteProfile(pqRs, wTitle);
                                if (!s) {
                                    return false;
                                }
                                pg = "message_box";
                                filter = {
                                    "0": {
                                        "first_contact": ["=", activeID],
                                        "second_contact": ["=", activeID]
                                    }
                                };
                                kvapi.get("/data/networking/conversation", {
                                    viewId: "mobile_app",
                                    filters: JSON.stringify(filter),
                                    sort: "last_message_date",
                                    dir: "DESC"
                                }).then(function (cb) {
                                    var context = {
                                        conversations: cb.response.records,
                                        conversationLength: cb.response.total,
                                        empty_text: rs.dynamicPageType.empty_text
                                    };
                                    context.reload = true;
                                    context.reloadData = {route: route, pageType: pageType, upPageType: upPageType}
                                    console.log(context);
                                    KV.dynamicRoute(pg, context);
                                });
                                break;
                            }
                            case 35: {
                                rs.back = 'main.html';
                                pqRs = rs;
                                if (rs.dynamicPageType.static_content_tr) {
                                    myApp.alert(rs.dynamicPageType.static_content_tr, "Bilgi", function () {
                                        KV.getProfilQuestion(pqRs);
                                    });
                                } else {
                                    KV.getProfilQuestion(pqRs);
                                }
                            }
                        }
                    }
                }
            });
        },

        openExhibitors: function (rs, allExhibitors, start) {
            // if (cb.response.total > allAnswer.length) {
            //     openAnswer(record_id, context, (start + 200), pageName);
            //     return false;
            // }
            myApp.showIndicator();
            var event_id = rs.dynamicPageType.event_name.value;

            kvapi.get("/data/event/exhibitor", {
                viewId: 'all',
                filters: JSON.stringify({
                    "event": ["=", event_id],
                    "organization": ["NOT EMPTY"]
                }),
                sort: 'rel_organization_label',
                dir: 'ASC',
                start: start,
                limit: 200
            }).then(function (cb) {
                allExhibitors = allExhibitors.concat(cb.response.records);
                if (cb.response.total > allExhibitors.length) {
                    KV.openExhibitors(rs, allExhibitors, (start + 200));
                    return false;
                }
                var records = allExhibitors;
                var x = {};
                for (var i = 0; i < records.length; ++i) {
                    if (records[i].organization.label) {
                        var obj = records[i];
                        //If a property for this FULLNAME FIRST LETTER does not exist yet, create
                        var key = KV.trkToUppercase(obj.organization.label.charAt(0));
                        obj.key = key;
                        obj.relatedData.organization.group = Math.floor(obj.relatedData.organization.record_id / 1000);
                        if (x[key] === undefined)
                            x[key] = []; //Assign a new array with the first element of FULLNAME FIRST LETTER.
                        //x will always be the array corresponding to the current FULLNAME FIRST LETTER. Push a value the current value to it.
                        x[key].push(obj);
                    }
                }
                var data = {
                    pageTitle: rs.pageTitle,
                    records: x,
                    upPageType: rs.upPageType,
                    event_id: event_id,
                    empty_text: rs.dynamicPageType.empty_text,
                    recordsLength: (Object.keys(x).length)
                };
                myApp.hideIndicator();
                var pg = 'katilimciUniversiteler';
                KV.dynamicRoute(pg, data);
            }).catch(function (cb) {
                KV.alertFail();
            });
        },

        openProfilePage: function (rs, ret) {
            console.log(ret);
            pg = 'profile';
            myApp.showIndicator();
            kvapi.get("/data/event/registration", {
                viewId: "mobile_app",
                filters: JSON.stringify({
                    "event_registration_id": ["=", activeID]
                })
            }).then(function (cb) {

                var userData = cb.response.records[0];
                if (userData.classroom) {
                    if (userData.classroom.value == 4) {
                        userData.classroom.value = 'Mezun'
                    }
                }

                if (userData.educational_status) {
                    var eduStatusArr = {1: "İlkokul", 2: "Ortaokul", 3: "Lise", 4: "Üniversite"};
                    userData.educational_status.value = eduStatusArr[userData.educational_status.value];
                }
                data = {
                    //pageTitle: rs.pageTitle, userData: userData, return: false
                    pageTitle: "Profilim",
                    userData: userData,
                    return: ret,
                    pqRs: rs
                }
                KV.dynamicRoute(pg, data);
            }).catch(function (cb) {
                console.log(cb);
            })
        }
        ,
        openNews: function (rs) { // Duyuruları Aç

            var now = new Date();
            now.addHours(3);
            var iso = now.toISOString().match(/(\d{4}\-\d{2}\-\d{2})T(\d{2}:\d{2}:\d{2})/);
            var filterDate = iso[1] + ' ' + iso[2];
            pg = "news";
            var records = [];
            kvapi.get("/data/event/news", {
                viewId: "mobile_app",
                filters: JSON.stringify({
                    "end_time": [">", filterDate],
                    "start_time": ["<", filterDate],
                    "active": ["=", "1"],
                    "registration": ["=", activeID]
                }),

            }).then(function (res) {
                console.log(res.response.records);

                records = res.response.records;


                kvapi.get("/data/event/news", {
                    viewId: "mobile_app",
                    filters: JSON.stringify({
                        "active": ["=", "1"],
                        "registration": ["EMPTY"]
                    })

                }).then(function (cb) {
                    console.log(cb.response);

                    var show_only_users = JSON.parse((localStorage.getItem("userData"))).allUserData.show_only_users.value;
                    $$.each(cb.response.records, function (index, value) {
                        value.newsDate = KV.setDate(value.created_on);
                        var grp = Math.floor(value.record_id / 1000);
                        value.thumbnail_url = "https://desktop.kivacrm.com/accounts/" + kivaAccountName + "/data/photo/event_news/grp_" + grp + "/thumb_" + value.thumb;

                        if (!value.show_only_users) {
                            records.push(value);
                        } else {
                            $$.each(value.show_only_users, function (sindex, svalue) {
                                if (svalue.value == 1 || svalue.value == show_only_users) {
                                    records.push(value);
                                }
                            });
                        }
                    });

                    console.log(records);


                    data = {
                        pageTitle: rs.pageTitle,
                        records: records,
                        empty_text: rs.dynamicPageType.empty_text
                    }
                    ;


                    KV.dynamicRoute(pg, data)

                }).catch(function (cb) {

                });
            });
            //KV.dynamicRoute(pg, rs);

        }
        ,
        openPoll: function (poll_type, rs) {
            console.log(poll_type, rs);

            if (poll_type) {
                if (!poll_type.r_id) {
                    if (KV.poll_type_menu) {
                        KV.alertFail();
                        return false;
                    }
                }
            }


            if (KV.order_poll) {
                var pageName = "main";
                if (KV.poll_type_menu) {
                    pageName = "poll_menu";
                }
                var dt = {
                    pageName: pageName,
                };

                if (KV.poll_type_menu) {
                    dt.poll_menu_type = poll_type.r_id;
                    dt.order_poll_end_info = poll_type.order_poll_end_info;
                }

                KV.filterAnsweredAndOrderPoll(1, dt);
            } else {


                var now = new Date();
                var iso = now.toISOString().match(/(\d{4}\-\d{2}\-\d{2})T(\d{2}:\d{2}:\d{2})/)
                var filterDate = iso[1] + ' ' + iso[2];
                var filters = {
                    "end_time": [">", filterDate],
                    "active": ["=", "1"],
                    "poll_type": ["=", "1"],
                    "registration": ["=", activeID]
                };


                console.log(filters);

                pg = "poll.html";

                var records = [];
                kvapi.get("/data/event/poll", {
                    viewId: "mobile_app",
                    filters: JSON.stringify(filters),
                    sort: "sort_order",
                    dir: "ASC"
                }).then(function (res) {
                    records = res.response.records;
                    $$.each(res.response.records, function (index, value) {
                        res.response.records[index].end_time = KV.setDate(value.end_time);
                    });
                    kvapi.get("/data/event/poll", {
                        viewId: "mobile_app",
                        filters: JSON.stringify({
                            "end_time": [">", filterDate],
                            "active": ["=", "1"],
                            "poll_type": ["=", "1"],
                            "registration": ["EMPTY"]
                        }),
                        sort: "sort_order",
                        dir: "ASC"
                    }).then(function (cb) {
                        var show_only_users = JSON.parse((localStorage.getItem("userData"))).allUserData.show_only_users.value;
                        $$.each(cb.response.records, function (index, value) {
                            value.end_time = KV.setDate(value.end_time);
                            if (!value.show_only_users) {
                                records.push(value);
                            } else {
                                $$.each(value.show_only_users, function (sindex, svalue) {
                                    if (svalue.value == 1 || svalue.value == show_only_users) {
                                        records.push(value);
                                    }
                                });
                            }
                        });
                        if (records.length < 1) {
                            KV.alertFail("Henüz anket tanımlanmamış.", "Bilgi.");
                            return false;
                        }
                        var rsp = {
                            records: records,
                            empty_text: rs.empty_text,
                        };

                        KV.dynamicRoute('poll', rsp);


                    })
                });
            }
        }
        ,
        filterAnsweredAndOrderPoll: function (poll_type, dt) {
            console.log("dtdtdt", dt);
            kvapi.get("/data/event/poll_record", {
                viewId: "mobile_app",
                filters: JSON.stringify({
                    "registration": ["=", activeID]
                })
            }).then(function (rs) {

                var now = new Date();
                var iso = now.toISOString().match(/(\d{4}\-\d{2}\-\d{2})T(\d{2}:\d{2}:\d{2})/)
                var filterDate = iso[1] + ' ' + iso[2];

                var filters = {};
                if (poll_type == 1) {
                    filters = {
                        "end_time": [">", filterDate],
                        "active": ["=", "1"],
                        "poll_type": ["=", poll_type],
                        "registration": ["EMPTY OR IN", [activeID]]
                    }

                    if (dt.poll_menu_type) {
                        filters.poll_menu_type = ["=", dt.poll_menu_type];
                    }
                }

                if (poll_type == 2) {
                    filters = {
                        "end_time": [">", filterDate],
                        "active": ["=", "1"],
                        "poll_type": ["=", poll_type]
                    };
                }
                console.log(filters);
                kvapi.get("/data/event/poll", {
                    viewId: "mobile_app",
                    filters: JSON.stringify(filters),
                    sort: "sort_order",
                    dir: "ASC"
                }).then(function (cb) {
                    console.log("allPoll", cb.response.records);
                    var show_only_users = JSON.parse((localStorage.getItem("userData"))).allUserData.show_only_users.value;
                    var filteredRecords = [];

                    var records = [];
                    $$.each(cb.response.records, function (index, value) {
                        if (!value.show_only_users) {
                            filteredRecords.push(value);
                        } else {
                            $$.each(value.show_only_users, function (sindex, svalue) {
                                if (svalue.value == 1 || svalue.value == show_only_users) {
                                    filteredRecords.push(value);
                                }
                            });
                        }
                    });

                    if (filteredRecords.length < 1) {
                        KV.alertFail("Anket soruları henüz girilmemiş.", "Bilgi");
                        return false;
                    }

                    $$.each(filteredRecords, function (index, value) {
                        ctrl = 0;
                        $$.each(rs.response.records, function (cevapIndex, cevapValue) {
                            if (value.record_id == cevapValue.poll.value) {
                                ctrl = 1;
                                return false;
                            }
                        });
                        if (ctrl == 1) {
                            return true;
                        }
                        if (ctrl == 0) {
                            records.push(value);
                        }
                    });
                    // console.log("filteredRecords", filteredRecords);


                    if (poll_type == 1) {
                        if (records.length < 1) {
                            myApp.hideIndicator();

                            var inf = (dt.order_poll_end_info) ? dt.order_poll_end_info : '';
                            myApp.alert("Tüm soruları tamamladığınız için teşekkür ederiz. " + inf, "Bilgi", function () {
                                var url = "main.html";
                                if (KV.poll_type_menu) {
                                    url = 'poll_menu.html';
                                }
                                mainView.router.load({
                                    url: url,
                                    reload: true,
                                });
                            });
                        } else {
                            console.log(records);
                            sendInitPoll(0, dt);

                            function sendInitPoll(index, dt) {
                                var context = {records: records, type: dt};
                                initPoll(records[index].record_id, context, dt.pageName);
                            }
                        }
                    }
                    if (poll_type == 2) {
                        // pReload = (myApp.getCurrentView().activePage.name != "profile") ? true : false;
                        // console.log(pReload);
                        if (records.length < 1) {
                            myApp.hideIndicator();

                            myApp.alert("Tüm soruları tamamladığınız için teşekkür ederiz.", "Bilgi", function () {
                                mainView.router.load({
                                    url: dt.back,
                                    reload: true
                                });
                            });
                        }
                        else {


                            getPoll(0);

                            function getPoll(index) {
                                var r_id = records[index].record_id;
                                kvapi.get("/custom/educaturk/pollAnswers/" + r_id, {}).then(function (response) {

                                    myApp.hideIndicator();
                                    if (response.response.total > 0) {
                                        pollViewData = {
                                            pollId: r_id,
                                            pollMaxSelect: records[index].max_selection,
                                            pollTitle: response.response.records[0].pollLabel,
                                            pollAnswers: response.response.records,
                                            back: dt.back
                                        };

                                        myApp.template7Data['page:profileQuestion'] = pollViewData;
                                        mainView.router.load({
                                            url: 'profileQuestion.html',
                                            reload: true
                                        });

                                    } else {
                                        if (records[index + 1]) {
                                            //myApp.alert("bir sonraki soruya geç");
                                            getPoll(index + 1);
                                        } else {
                                            myApp.alert("Tüm soruları tamamladığınız için teşekkür ederiz.", "Bilgi", function () {
                                                mainView.router.load({
                                                    url: dt.back,
                                                    reload: true

                                                });
                                            });


                                        }
                                    }

                                });

                                /*
                                 kvapi.get("/data/event/poll_answer", {
                                 viewId: "mobile_app",
                                 filters: JSON.stringify({
                                 "poll": ["=", r_id],
                                 })
                                 }).then(function (response) {
                                 myApp.hideIndicator();
                                 if (response.response.total > 0) {
                                 pollViewData = {
                                 pollId: r_id,
                                 pollMaxSelect: records[index].max_selection,
                                 pollTitle: response.response.records[0].poll.label,
                                 pollAnswers: response.response.records,
                                 }


                                 myApp.template7Data['page:profileQuestion'] = pollViewData;
                                 mainView.router.load({
                                 url: 'profileQuestion.html',
                                 reload: true
                                 });


                                 } else {
                                 if (records[index + 1]) {
                                 //myApp.alert("bir sonraki soruya geç");
                                 getPoll(index + 1);
                                 } else {
                                 myApp.alert("Tüm soruları tamamladığınız için teşekkür ederiz.", "Bilgi", function () {
                                 mainView.router.load({
                                 url: 'profile.html',
                                 reload: pReload

                                 });
                                 });


                                 }
                                 }
                                 });
                                 */
                            }

                        }
                    }
                }).catch(function (rs) {
                    console.log(rs);
                    KV.alertFail();
                });
            }).catch(function (rs) {
                console.log(rs);
                KV.alertFail();
            });
        }
        ,
        toConverstaion: function (params, from) {
            console.log("params", params);
            activeConversation = params.conversation_label;
            var filter = {"conversation_label": ["=", params.conversation_label]};
            myApp.showIndicator();
            kvapi.get("/data/networking/conversation", {
                viewId: "mobile_app",
                filters: JSON.stringify(filter)
            }).then(function (rs) {


                if (rs.response.total == 0) {
                    var isContactPerson = JSON.parse(localStorage.getItem("userData")).allUserData.contact_exhibitor_person;
                    console.log(isContactPerson);
                    conversation = null;
                    var pageObj = {
                        toBack: params.toBack,
                        messages: [],
                        toParticipant: params.toParticipant,
                        toParticipantId: params.toParticipantId,
                        conversation: conversation,
                        conversation_label: params.conversation_label,
                        toConversationPage: params.toConversationPage,
                        msg: params.msg,
                        space_booking: params.space_booking,
                        isContactPerson: isContactPerson,
                        reload: params.reload,
                        reloadData: params.reloadData
                    };

                    myApp.hideIndicator();

                    if (!from) {
                        myApp.template7Data['page:conversation'] = pageObj;
                        mainView.router.load({
                            reload: true,
                            url: 'conversation.html'
                        });
                    }
                    else if (from == 'toReserve') {
                        contacts = params.conversation_label.split("-");
                        first_contact = contacts[0];
                        second_contact = contacts[1];

                        kvapi.post("/data/networking/conversation", {
                            records: [
                                {
                                    conversation_label: params.conversation_label,
                                    first_contact: first_contact,
                                    second_contact: second_contact
                                }
                            ]
                        })
                            .then(function (convResp) {
                                if (convResp.response.failed != 0 || !convResp.response.success) {
                                    myApp.hideIndicator();
                                    myApp.alert("This conversation can not be started. Try again later.", "Attention!");
                                } else {
                                    pageObj.conversation = convResp.response.records[0].record_id;
                                    KV.saveToCrmMessage(pageObj);
                                }
                            });
                    }

                }
                else {
                    conversation = rs.response.records[0].record_id;


                    if (!from) {
                        var dir = "DESC";
                        var sort_order = "created_on";
                        var limit = 10;
                        var filter = {"conversation": ["=", conversation]};
                        kvapi.get("/data/networking/message", {
                            viewId: "mobile_app",
                            filters: JSON.stringify(filter),
                            sort: sort_order,
                            dir: dir,
                            limit: limit
                        })
                            .then(function (response) {
                                myApp.hideIndicator();
                                var isContactPerson = JSON.parse(localStorage.getItem("userData")).allUserData.contact_exhibitor_person;
                                console.log(isContactPerson);
                                var messages = response.response.records.reverse();
                                var pageObj = {
                                    toBack: params.toBack,
                                    messages: messages,
                                    toParticipant: params.toParticipant,
                                    toParticipantId: params.toParticipantId,
                                    conversation: conversation,
                                    isContactPerson: isContactPerson,
                                    reload: params.reload,
                                    reloadData: params.reloadData
                                };
                                myApp.template7Data['page:conversation'] = pageObj;
                                mainView.router.load({
                                    reload: true,
                                    url: 'conversation.html'
                                });
                            });
                    }
                    else if (from == 'toReserve') {
                        var pageObj = {
                                toBack: params.toBack,
                                toParticipant: params.toParticipant,
                                toParticipantId: params.toParticipantId,
                                conversation: conversation,
                                msg: params.msg,
                                toConversationPage: params.toConversationPage,
                                conversation_label: params.conversation_label,
                                space_booking: params.space_booking
                            }
                        ;
                        KV.saveToCrmMessage(pageObj);
                    }
                }
            });
        }
        ,
        alertFail: function (msg, title) {
            myApp.hideIndicator();
            if (!msg) {
                msg = "Bir hata oluştu. Lütfen yetkiliyle görüşünüz.";
            }
            if (!title) {
                title = "Hata!";
            }
            myApp.alert(msg, title);
        }
        ,
        saveToCrmMessage: function (s) {
            kvapi.post("/data/networking/message", {
                records: [
                    {
                        from: activeID,
                        to: s.toParticipantId,
                        conversation: s.conversation,
                        content: s.msg,
                        space_booking: s.space_booking

                    }
                ]
            })
                .then(function (rs) {
                    myApp.hideIndicator();

                    if (rs.response.failed != 0 || !rs.response.success) {

                    } else if (rs.response.failed == 0) {
                        if (s.toConversationPage) {
                            KV._toConverstaion(s)
                        }
                    }
                });

        }
        ,
        sortByLabel: function (data, where) {
            var x = {};
            for (var i = 0; i < data.length; ++i) {
                var obj = data[i];
                //If a property for this FULLNAME FIRST LETTER does not exist yet, create
                var key = KV.trkToUppercase(obj[where].label.charAt(0));
                obj.key = key;
                obj.myID = parseInt(activeID);
                if (x[key] === undefined)
                    x[key] = []; //Assign a new array with the first element of FULLNAME FIRST LETTER.
                //x will always be the array corresponding to the current FULLNAME FIRST LETTER. Push a value the current value to it.
                x[key].push(obj);
            }

            function compare(a, b) {
                if (a[where].label < b[where].label)
                    return -1;
                if (a[where].label > b[where].label)
                    return 1;
                return 0;
            }

            $$.each(x, function (index, value) {
                $$.each(value, function (ii, vv) {
                    if (vv[where]) {
                        x[index].sort(compare);
                    }
                })

            });

            function sortComparer(a, b) {
                return a.localeCompare(b)
            }


            var y = {};
            Object.keys(x)
                .sort(sortComparer)
                .forEach(function (v, i) {
                    y[v] = x[v];
                });
            return y;
        }
        ,
        dynamicRoute: function (page, rs) {
            t7 = 'page:' + page;
            myApp.template7Data[t7] = rs;
            myApp.hideIndicator();
            mainView.router.load({
                reload: true,
                //reloadPrevious: true,
                url: page + '.html'
            });
        }
        ,
        initMenu: function (menuArrayTemp, pageType, recordId, getupId, addMainNav) {
            // console.log("MenuArrayTemp", menuArrayTemp);
            // console.log("pageType", pageType);
            // console.log("recordId", recordId);
            // console.log("getupId", getupId);
            // console.log("addMainNav", addMainNav);
            // console.log("initMenu");
            var menuArray = [];

            var index = (!recordId) ? 0 : null;

            var routerUrl = 'main.html';
            if (pageType == 'parentMenuExtended' || pageType == 'parentMenuExtended-2') {

                var subArray = [];
                routerUrl = 'mainExtended.html';
                menuArray = menuArrayTemp;


                var pickerValue = [];


                var pickerLabel = [];
                var control = 0;

                for (var l = 0; l < menuArray.length; l++) {

                    if (recordId == menuArray[l].record_id) {
                        index = l;
                        control = 1;
                    }

                    if (control == 0) {
                        if (menuArray[l].gosterilme_tarihi) {
                            //var g_tarihi = (KV.setDate(menuArray[l].gosterilme_tarihi));
                            tmp = menuArray[l].gosterilme_tarihi.split('+');
                            g_tarihi = Date.parse(tmp[0]);
                            now_ = Date.parse(new Date());
                            if (g_tarihi < now_) {
                                index = l;
                            }
                        }
                    }

                    pickerLabel[l] = menuArray[l].menu_title_tr;
                    pickerValue[l] = menuArray[l].record_id;

                    if (menuArray[l].sub) {
                        for (var k = 0; k < menuArray[l].sub.length; k++) {
                            menuArray[l].sub[k].upRecord = menuArray[l].record_id;
                        }
                    }

                }

                static_content_tr = ('null' != menuArray[index].static_content_tr) ? menuArray[index].static_content_tr : '';

                var subArrayTemp = [];
                if (menuArray[index].sub) {
                    subArrayTemp = (menuArray[index].sub);
                    while (subArrayTemp.length > 9) {
                        subArray.push(subArrayTemp.splice(0, 9));
                    }
                }


                subArray.push(subArrayTemp);

                var x = [];
                var t = 0;
                for (var p = 0; p < subArray.length; p++) {
                    for (r = 0; r < subArray[p].length; r++) {
                        x[t] = subArray[p][r];
                        t++;

                    }
                }


                menuArray[index].sub = x;


                if (getupId) {
                    pageTitle = KV.menu[getupId].menu_title_tr;
                    //static_content_tr = KV.menu[getupId].static_content_tr;
                }


                var context = {
                    "menu": menuArray,
                    "sub": subArray,
                    "pickerValue": pickerValue,
                    "pickerLabel": pickerLabel,
                    "index": index,
                    "pageTitle": pageTitle,
                    "static_content_tr": static_content_tr,
                };

                myApp.template7Data['page:mainExtended'] = context;

            } else {

                while (menuArrayTemp.length > 9) {
                    menuArray.push(menuArrayTemp.splice(0, 9));
                }
                menuArray.push(menuArrayTemp);


                if (addMainNav) {
                    menuArray[0].backMainMenu = true;
                    mainMenuDepth = 1;
                }
                else {
                    mainMenuDepth = 0;
                    var x = [];
                    var t = 0;
                    for (var p = 0; p < menuArray.length; p++) {
                        for (r = 0; r < menuArray[p].length; r++) {
                            x[t] = menuArray[p][r];
                            t++;

                            //message box unread badge
                            if (JSON.parse((localStorage.getItem("userData"))).allUserData.unread) {
                                menuArray[p][r].badge = '';
                                if (menuArray[p][r].relatedData.dynamic_page_link) {
                                    if (menuArray[p][r].relatedData.dynamic_page_link.dynamic_page_type) {
                                        if (menuArray[p][r].relatedData.dynamic_page_link.dynamic_page_type.value == 34) {
                                            menuArray[p][r].badge = '<div class="badgeSpan2">' + JSON.parse((localStorage.getItem("userData"))).allUserData.unread + '</div>';
                                        }
                                    }

                                }
                            }
                            // /message box unread badge

                        }
                    }
                    KV.mainMenu = x;

                }


                var context = {"menu": menuArray};
                myApp.template7Data['page:main'] = context;

            }

            myApp.hideIndicator();

            mainView.router.load({
                reload: true,
                url: routerUrl,
            });
        }
        ,
        setLeftPanel: function (menu) {
            var html = '';
            $$.each(menu, function (index, value) {
                var subHtml = '';

                if (value.sub && value.pageType != "parentMenuExtended") {
                    var subSubHtml = '';
                    $$.each(value.sub, function (subIndex, subValue) {
                        if (subValue.sub) {
                            $$.each(subValue.sub, function (subSubIndex, subSubValue) {
                                // external setting
                                var externalClass = '';
                                var href = '#';
                                if (subSubValue.external_page_link) {
                                    href = subSubValue.external_page_link;
                                    externalClass = 'external';
                                }

                                isRouteClass = (subSubValue.route) ? 'class="crmMenu close-panel" pageType =' + subSubValue.pageType + ' route=' + subSubValue.route : '';
                                var w = (subSubValue.icon) ? '24' : '0';
                                subSubHtml += '<li ' + isRouteClass + '>' +
                                    '<div class="item-content ' + externalClass + '" href="' + href + '">' +
                                    '<div class="item item-inner"  style="margin-left:50px;">' +
                                    '<div class="item-title"><i style="width: ' + w + 'px; text-align: center" class="fa fa-' + subSubValue.icon + '" aria-hidden="true"></i>' + subSubValue.menu_title_tr + '</div>' +
                                    '</div>' +
                                    '</div>' +
                                    '</li>';
                                return false;
                            });

                            subSubHtml = '<div class="accordion-item-content">' +
                                '<div class="list-block">' +
                                '<ul>' +
                                subSubHtml +
                                '</ul>' +
                                '</div>' +
                                '</div>';

                        }

                        isRouteClass = (subValue.route) ? 'class="crmMenu close-panel" pageType =' + subValue.pageType + ' route=' + subValue.route : 'class="accordion-item"';


                        var externalClass = '';
                        var href = '#';
                        if (subValue.external_page_link) {
                            href = subValue.external_page_link;
                            externalClass = 'external';
                        }
                        var w = (subValue.icon) ? '24' : '0';
                        subHtml += '<li ' + isRouteClass + '>' +
                            '<a href="' + href + '" class="item-link item-content ' + externalClass + '">' +
                            '<div class="item-inner"  style="margin-left:29px;">' +
                            '<div class="item-title"><i style="width: ' + w + 'px; text-align: center" class="fa fa-' + subValue.icon + '" aria-hidden="true"></i>' + subValue.menu_title_tr + '</div>' +
                            '</div>' +
                            '</a>' + subSubHtml +
                            '</li>';
                        return false;
                    });


                    subHtml = '<div class="accordion-item-content">' +
                        '<div class="list-block">' +
                        '<ul>' +
                        subHtml +
                        '</ul>' +
                        '</div>' +
                        '</div>';

                }

                isRouteClass = (value.route != null) ? 'class="crmMenu close-panel" pageType =' + value.pageType + ' route=' + value.route : 'class="accordion-item"';


                var w = (value.icon) ? '24' : '0';
                var externalClass = '';
                var href = '#';
                if (value.external_page_link) {
                    href = value.external_page_link;
                    externalClass = 'external';
                }
                var isRouteClass = (value.pageType == "parentMenuExtended") ? 'class="crmMenu close-panel" pageType =' + value.pageType + ' r_id=' + value.record_id : isRouteClass;
                html += '<li ' + isRouteClass + '><a href="' + href + '" class="item-link item-content ' + externalClass + '" r_id="' + value.record_id + '">' +
                    '<div class="item-inner">' +
                    '<div class="item-title"><i style="width:' + w + 'px; text-align: center" class="fa fa-' + value.icon + '" aria-hidden="true"></i>&nbsp;' + value.menu_title_tr + '</div>' +
                    '</div></a>' +
                    subHtml +
                    '</li>';


            });
            // html += '<li id="logoutFromDevice" class="close-panel"><a href="#" class="item-link item-content">' +
            //     '<div class="item-inner">' +
            //     '<div class="item-title"><i style="width:24px; text-align: center" class="fa fa-sign-out" aria-hidden="true"></i>&nbsp;Çıkış</div>' +
            //     '</div></a>' +
            //     '</li>';

            $$('#accordion-menu').append(html);

            $$('.crmMenu').on('click', function (e) {
                var pageType = $$(this).attr("pageType");
                if (pageType != 'parentMenuExtended') {
                    var route = $$(this).attr("route");
                    KV.getStaticPage(route, pageType);
                } else {
                    var record_id = $$(this).attr("r_id");
                    KV.activeExtended = record_id;
                    var item = KV.menu[record_id];
                    KV.initMenu(item.sub, pageType, '', record_id);

                }
            });


            $$('.parentExtended-menu-item').on('click', function (e) {
                var recordId = $(this).attr("r_id");
            });

            $$('#logoutFromDevice').on('click', function (e) {
                sessionStorage.clear();
                localStorage.clear();
                $$('.toolbar-bottom').css("z-index", "-1");
                $$('.navbar').css("z-index", "-1");
                KV.getConfig();
            });
        }
        ,
        setDate: function (date) {

            var time = date.split("T");
            var r = time[0].split('-');
            time = r[2] + '-' + r[1] + '-' + r[0] + ' ' + (time[1].split("+"))[0];
            return time;
        }
        ,
        validateEmail: function (email) {
            var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            return re.test(email);
        }
        ,
        alignCenter: function (div) {
            var wHeight = $$(window).height();
            var divHeight = $$(div).height();
            var Hprocess = (wHeight - divHeight) / 2;
            $$(div).css({"top": Hprocess + "px"});

            var wWidth = $$(window).width();
            var divWidth = $$(div).width();
            var Wprocess = (wWidth - divWidth) / 2;
            $$(div).css({"left": Wprocess + "px"});
        }
        ,
        md5: function (value) {
            return CryptoJS.MD5(value).toString();
        }
        ,
        getQrData: function (text) {

            var returnText = text;
            var regExp = /\{\{([^}]+)\}\}/g;

            var match;
            while ((match = regExp.exec(text)) != null) {
                var forReplace = match[0];
                var processData = match[1];
                var processDataArray = processData.split(':');

                switch (processDataArray[0]) {
                    case 'user_id':
                        if (processDataArray[1] == 'active_id') {
                            var str = '{{user_id:' + activeID + '}}';
                            returnText = returnText.replace(forReplace, str);
                        }
                }
            }

            return (returnText);


        }
        ,
        openQrCodeReader: function () {
            function decodeBarcodeText(text) {
                var splitedText = text.split("|");

                var obj = {
                    registration: activeID,
                    fullname: splitedText[2],
                    organization: splitedText[3],
                    email: splitedText[4],
                    phone: splitedText[5],
                    title: splitedText[6]
                };

                return obj;

                console.log(obj);
            }

            // $$('#openQrReader').on('click', function () {

            myApp.hideIndicator();

            cordova.plugins.barcodeScanner.scan(
                function (result) {
                    if (result.cancelled == 0 && result.text) {
                        kvapi.post("/data/networking/contact_list", {
                            //triggerWF: true, // iş akışı kuralı var ise çalıştır
                            upsert: true, // mükerrer kayıt var ise güncelle
                            upsertFields: ["phone"],
                            upsertIfEmpty: true,
                            records: [
                                decodeBarcodeText(result.text)
                            ]
                        })
                            .then(function (rs) {
                                console.log(rs);
                                var dialog = myApp.modal({
                                    title: 'Bilgi!',
                                    text: 'İletişimlerinize Eklendi.',
                                    buttons: [
                                        {
                                            text: 'Tamam',
                                            onClick: function () {
                                                myApp.closeModal(dialog);
                                            }
                                        },
                                        {
                                            text: 'Yeni Ekle',
                                            onClick: function () {
                                                KV.openQrCodeReader();
                                            }
                                        },

                                    ]
                                });

                            })
                            .catch(function (rs) {
                                alert(JSON.stringify((rs)));

                            });
                    }
                },
                function (error) {
                    alert("Scanning failed: " + error);
                },
                {
                    "preferFrontCamera": false, // iOS and Android
                    "showFlipCameraButton": false, // iOS and Android
                    "prompt": "Lütfen QR kodu buradan okutunuz", // supported on Android only
                    "formats": "QR_CODE", // default: all but PDF_417 and RSS_EXPANDED
                    "orientation": "landscape" // Android only (portrait|landscape), default unset so it rotates with the device
                }
            );
        }
        ,
        trkToUppercase: function (text) {
            var str = [];
            for (var i = 0; i < text.length; i++) {
                var ch = text.charCodeAt(i);
                var c = text.charAt(i);
                if (ch == 105) str.push('İ');
                else if (ch == 305) str.push('I');
                else if (ch == 287) str.push('Ğ');
                else if (ch == 252) str.push('Ü');
                else if (ch == 351) str.push('Ş');
                else if (ch == 246) str.push('Ö');
                else if (ch == 231) str.push('Ç');
                else if (ch >= 97 && ch <= 122)
                    str.push(c.toUpperCase());
                else
                    str.push(c);
            }
            return str.join('');
        }
        ,
        openPhotoBrowser: function () {
            var containerHeight = $$('.photo-browser-swiper-container').height();
            var setHeight = parseInt(containerHeight) - 125;
            $$('.photo-browser-slide img').css("max-height", setHeight + "px");
            $$('.photo-browser-swiper-container').addClass("bg2");
        }
        ,
        openExternal: function (href) {

        }
        ,
        warningCompleteProfile: function (pqRs, wTitle) {
            console.log("warn", pqRs);

            var show_only_users = JSON.parse((localStorage.getItem("userData"))).allUserData.show_only_users.value;
            console.log(show_only_users);
            var u = JSON.parse((localStorage.getItem("userData"))).allUserData;
            console.log(u);


            var ctrl = 0;
            if ([2, 3, 5, 6].indexOf(show_only_users) != -1) {
                console.log("ABCD")
                if (!u.firstname || !u.lastname || !u.email || !u.relatedData.part_contact.phone || !u.relatedData.part_contact.date_of_birth || !u.contact_preferences || !u.address_city) {
                    ctrl = 1;
                }
            }

            if ([2, 5, 6].indexOf(show_only_users) != -1) {
                if (!u.title) {
                    ctrl = 1;
                }
            }

            if ([2, 3, 6].indexOf(show_only_users) != -1) {
                if (!u.relatedData.part_contact.gender) {
                    ctrl = 1;
                }
            }

            if ([2, 3].indexOf(show_only_users) != -1) {
                if (!u.organization_non_exhibitor) {
                    ctrl = 1;
                }
            }

            if (show_only_users == 2) {
                if (!u.grad_uni) {
                    ctrl = 1;
                }
            }

            if (show_only_users == 3) {
                if (!u.classroom || !u.student_department) {
                    ctrl = 1;
                }
            }

            if (show_only_users == 5) {
                if (!u.educational_status) {
                    ctrl = 1;
                }
            }

            if (show_only_users == 6) {
                if (!u.organization) {
                    ctrl = 1;
                }
            }

            // ctrl = 0;
            console.log("ctrl", 0);
            myApp.hideIndicator();
            if (ctrl) {
                myApp.modal({
                    title: 'Dikkat.',
                    text: wTitle,
                    buttons: [
                        {
                            text: 'Vazgeç',
                            onClick: function () {
                            }
                        },
                        {
                            text: 'Profili Tamamla',
                            onClick: function () {
                                if (pqRs.back == 'profile.html') {
                                    //KV.openProfilePage(null, null);
                                } else {
                                    KV.openProfilePage(null, {
                                        route: pqRs.routeOrigin,
                                        pageType: pqRs.pageType,
                                        upPageType: pqRs.upPageType
                                    });
                                }
                            }
                        },
                    ]
                });
                return false;
            } else {
                return true;
            }
        }
        ,

        getProfilQuestion: function (pqRs) {
            console.log(pqRs)
            var show_only_users = JSON.parse((localStorage.getItem("userData"))).allUserData.show_only_users.value;
            console.log(show_only_users);
            // var u = JSON.parse((localStorage.getItem("userData"))).allUserData;
            // console.log(u);
            //
            // if ([2, 3, 5, 6].indexOf(show_only_users) != -1) {
            //     if (!u.firstname || !u.lastname || !u.email || !u.relatedData.part_contact.phone || !u.relatedData.part_contact.date_of_birth || !u.contact_preferences || !u.address_city) {
            //         console.log("a1");
            //         KV.warningCompleteProfile(pqRs);
            //         return;
            //     }
            // }
            //
            // if ([2, 5, 6].indexOf(show_only_users) != -1) {
            //     if (!u.title) {
            //         console.log("a2");
            //         KV.warningCompleteProfile(pqRs);
            //         return;
            //     }
            // }
            //
            // if ([2, 3, 6].indexOf(show_only_users) != -1) {
            //     if (!u.relatedData.part_contact.gender) {
            //         console.log("a3");
            //         KV.warningCompleteProfile(pqRs);
            //         return;
            //     }
            // }
            //
            // if ([2, 3].indexOf(show_only_users) != -1) {
            //     if (!u.organization_non_exhibitor) {
            //         console.log("a4");
            //         KV.warningCompleteProfile(pqRs);
            //         return;
            //     }
            // }
            //
            // if ([2, 5].indexOf(show_only_users) != -1) {
            //     console.log(show_only_users);
            //     if (!u.grad_uni) {
            //         console.log("a5");
            //         KV.warningCompleteProfile(pqRs);
            //         return;
            //     }
            // }
            //
            // if (show_only_users == 3) {
            //     if (!u.classroom || !u.student_department) {
            //         console.log("a6");
            //         KV.warningCompleteProfile(pqRs);
            //         return;
            //     }
            // }
            //
            // if (show_only_users == 6) {
            //     if (!u.organization) {
            //         console.log("a7");
            //         KV.warningCompleteProfile(pqRs);
            //         return;
            //     }
            // }
            var s = KV.warningCompleteProfile(pqRs, "Bu menüyü görebilmek için profilinizi tamamlamalısınız.");
            if (s) {
                myApp.showIndicator();
                KV.filterAnsweredAndOrderPoll(2, pqRs);
            }
            return;
            // // Gerekli bilgilerin kontrolü
            // var show_only_users = JSON.parse((localStorage.getItem("userData"))).allUserData.show_only_users.value;
            // // console.log(show_only_users);
            // //
            // // if ([2, 3, 5, 6].indexOf(show_only_users){
            // //     console.log("hepsi"); // ad, soyad, eposta, ceptel
            // // }
            // //
            // // if ([2, 3, 6].indexOf(show_only_users)) {
            // //     //şehir
            // // }
            // //
            // // if (show_only_users == 2) {
            // //     //title
            // // }
            // //
            // // if (show_only_users == 6) {
            // //     //kurum (exxhibitor)
            // // }
            // //
            // // if ([2, 3].indexOf(show_only_users)) {
            // //     //kurum non exhibitor
            // // }
            // //
            // // if (show_only_users == 3) {
            // //     //class, alan
            // // }
            //
            // myApp.showIndicator();
            //
            // kvapi.get("/data/event/poll_record", {
            //     viewId: "mobile_app",
            //     filters: JSON.stringify({
            //         "registration": ["=", activeID]
            //     })
            // }).then(function (rs) {
            //
            //     kvapi.get("/data/event/poll", {
            //         viewId: "mobile_app",
            //         filters: JSON.stringify({
            //             "active": ["=", "1"],
            //             "poll_type": ["=", "2"],
            //         }),
            //         sort: "sort_order",
            //         dir: "ASC"
            //     }).then(function (cb) {
            //         // console.log("allPool", cb.response.records);
            //         var filteredRecords = [];
            //
            //         var records = [];
            //         $$.each(cb.response.records, function (index, value) {
            //             if (!value.show_only_users) {
            //                 filteredRecords.push(value);
            //             } else {
            //                 $$.each(value.show_only_users, function (sindex, svalue) {
            //                     if (svalue.value == 1 || svalue.value == show_only_users) {
            //                         filteredRecords.push(value);
            //                     }
            //                 });
            //             }
            //         });
            //
            //         $$.each(filteredRecords, function (index, value) {
            //             ctrl = 0;
            //             $$.each(rs.response.records, function (cevapIndex, cevapValue) {
            //                 if (value.record_id == cevapValue.poll.value) {
            //                     ctrl = 1;
            //                     return false;
            //                 }
            //             });
            //             if (ctrl == 1) {
            //                 return true;
            //             }
            //             if (ctrl == 0) {
            //                 records.push(value);
            //             }
            //         });
            //         // console.log("filteredRecords", filteredRecords);
            //         pReload = (myApp.getCurrentView().activePage.name != "profile") ? true : false;
            //
            //         if (records.length < 1) {
            //             myApp.hideIndicator();
            //
            //             myApp.alert("Tüm soruları tamamladığınız için teşekkür ederiz.", "Bilgi", function () {
            //                 mainView.router.load({
            //                     url: 'profile.html',
            //                     reload: pReload
            //                 });
            //             });
            //         } else {
            //
            //             console.log("asdasd");
            //             getPoll(0);
            //
            //             function getPoll(index) {
            //                 // console.log("getpoll", records)
            //                 //
            //                 // console.log(index);
            //                 // console.log("record_index", records[index]);
            //                 var r_id = records[index].record_id;
            //                 kvapi.get("/custom/educaturk/pollAnswers/" + r_id, {}).then(function (response) {
            //
            //                     myApp.hideIndicator();
            //                     if (response.response.total > 0) {
            //                         pollViewData = {
            //                             pollId: r_id,
            //                             pollMaxSelect: records[index].max_selection,
            //                             pollTitle: response.response.records[0].pollLabel,
            //                             pollAnswers: response.response.records,
            //                             back: pqRs.back
            //                         };
            //
            //                         myApp.template7Data['page:profileQuestion'] = pollViewData;
            //                         mainView.router.load({
            //                             url: 'profileQuestion.html',
            //                             reload: true
            //                         });
            //
            //                     } else {
            //                         if (records[index + 1]) {
            //                             //myApp.alert("bir sonraki soruya geç");
            //                             getPoll(index + 1);
            //                         } else {
            //                             myApp.alert("Tüm soruları tamamladığınız için teşekkür ederiz.", "Bilgi", function () {
            //                                 mainView.router.load({
            //                                     url: 'profile.html',
            //                                     reload: pReload
            //
            //                                 });
            //                             });
            //
            //
            //                         }
            //                     }
            //
            //                 });
            //
            //                 /*
            //                  kvapi.get("/data/event/poll_answer", {
            //                  viewId: "mobile_app",
            //                  filters: JSON.stringify({
            //                  "poll": ["=", r_id],
            //                  })
            //                  }).then(function (response) {
            //                  myApp.hideIndicator();
            //                  if (response.response.total > 0) {
            //                  pollViewData = {
            //                  pollId: r_id,
            //                  pollMaxSelect: records[index].max_selection,
            //                  pollTitle: response.response.records[0].poll.label,
            //                  pollAnswers: response.response.records,
            //                  }
            //
            //
            //                  myApp.template7Data['page:profileQuestion'] = pollViewData;
            //                  mainView.router.load({
            //                  url: 'profileQuestion.html',
            //                  reload: true
            //                  });
            //
            //
            //                  } else {
            //                  if (records[index + 1]) {
            //                  //myApp.alert("bir sonraki soruya geç");
            //                  getPoll(index + 1);
            //                  } else {
            //                  myApp.alert("Tüm soruları tamamladığınız için teşekkür ederiz.", "Bilgi", function () {
            //                  mainView.router.load({
            //                  url: 'profile.html',
            //                  reload: pReload
            //
            //                  });
            //                  });
            //
            //
            //                  }
            //                  }
            //                  });
            //                  */
            //             }
            //
            //         }
            //         // myApp.template7Data['page:poll'] = records;
            //         //
            //         // mainView.router.load({
            //         //     reload: true,
            //         //     url: pg,
            //         // });
            //     }).catch(function (rs) {
            //         KV.alertFail();
            //     });
            // }).catch(function (rs) {
            //     KV.alertFail();
            // });
        }
        ,

        customAutoComplete: function (t_this) {
            var dataFrom = $$(t_this).attr("dataFrom");
            console.log(dataFrom);
            if (dataFrom == "json") {
                var where = $$(t_this).attr("autoCompleteData");
                $$.getJSON('json/' + where + '.json', function (data) {
                    contextData = data;
                    //console.log(contextData);
                    var aHtml = '';
                    $$.each(contextData, function (index, value) {

                        aHtml += '<li class="customItem">' +
                            '<label class="label-radio item-content">' +
                            '<!-- Checked by default -->' +
                            '<input type="radio" name="pollRadio" class="radioIn" style="text-transform:capitalize" value="' + value.addr_city_id + '">' +
                            '<div class="item-inner">' +
                            '<div class="item-title city_name" style="color:black">' + value.city_name + '</div>' +
                            '</div>' +
                            '</label>' +
                            '</li>';
                    });
                    $$("#autoCompleteUl").html(aHtml);
                    myApp.popup('.popup-customAutoComplete');

                    $$(".customItem").on("click", function () {
                        var record_id = $$(this).find('.radioIn').val();
                        var city_name = $$(this).find('.city_name').html();
                        console.log(record_id, city_name);
                        $$(t_this).find('.idZone').val(record_id);
                        $$(t_this).find('.valueZone').val(city_name);
                        myApp.closeModal(".popup-customAutoComplete");
                    });

                });
            }
        }
        ,

        kvPushTest: function () {
            KV.pushMenuTest = true;
            if (KV.pushMenuTest) {
                console.log("Notification Test Ediliyor..");
                //for menu
                var data = '{"message":"Menüye Yönlendirme","title":"Test","notification":{"body":"Test Text","title":"Test121","sound":"default","badge":"1","menu":174},"data":{"count":1,"info":"push message info","message":"Test Text","title":"Test121","notification_type":1,"menu":174},"priority":"high","registration_ids":[null]}';
                //for page
                //var data = '{"message":"Sayfaya Yönlendirme","title":"Test","notification":{"body":"Test Text","title":"Test121","sound":"default","badge":"1","page":"\/6-bize-ulasin"},"data":{"count":1,"info":"push message info","message":"Test Text","title":"Test121","notification_type":2,"page":"\/6-bize-ulasin"},"priority":"high","registration_ids":[null]}';
                //for poll
                //var data = '{"message":"Ankete Yönlendirme","title":"Test","notification":{"body":"Test Text","title":"Test121","sound":"default","badge":"1","poll":18},"data":{"count":1,"info":"push message info","message":"Test Text","title":"Test121","notification_type":3,"poll":18},"priority":"high","registration_ids":[null]}';
                //for news
                //var data = '{"message":"Duyuruya Yönlendirme","title":"Test","notification":{"body":"Test Text","title":"Test121","sound":"default","badge":"1","news":35},"data":{"count":1,"info":"push message info","message":"Test Text","title":"Test121","notification_type":4,"news":35},"priority":"high","registration_ids":[null]}';
                //for conversation
                //var data = '{"message":"Konuşmaya Yönlendirme","title":"test","data":{"count":1,"info":"push message info","message":"Yeni Mesaj","title":"Educaturk","conversation":{"conversation_label":"97-12650","toParticipantId":97,"toParticipant":{"firstname":"Erdem","lastname":"asdsad","profile_photo":null,"email":"erdem.akca@kiva.com.tr","organization_logo":"grp_0\/thumb_661a26fec4cee43a17cadeff955ee345.png","organization":{"value":120,"label":"Kiva Teknoloji"}},"message":"test"},"notification_type":6},"priority":"high","registration_ids":["fWt4MHBtZTM:APA91bHMPfC41dGlvW5Tw2c75JuSLI1EbqzyQIAjtBMV8fl6UQt0WCRqc3hItZ_9XC940FdJbb0Z4Xf9_bqLqbF17jB3FHdwJgir5dzA9gfQ4IU0kgjB4qBtMRSZUCKTqDX93UkJ-Ibs"],"notification":{"conversation":{"conversation_label":"97-12650","toParticipantId":97,"toParticipant":{"firstname":"Erdem","lastname":"asdsad","profile_photo":null,"email":"erdem.akca@kiva.com.tr","organization_logo":"grp_0\/thumb_661a26fec4cee43a17cadeff955ee345.png","organization":{"value":120,"label":"Kiva Teknoloji"}},"message":"test"}}}';
                data = JSON.parse(data);
                data.additionalData = data.data;
                console.log("Notification Data", data);

                switch (data.additionalData.notification_type) {
                    case 1: {
                        var item = KV.menu[data.additionalData.menu];
                        if (item) {
                            if (item.sub) {
                                myApp.alert(data.message, data.title, function () {
                                    if (data.additionalData != undefined) {
                                        if (data.additionalData.menu != undefined) {
                                            KV.activeExtended = data.additionalData.menu;
                                            var pageType = (item.pageType) ? item.pageType : null;
                                            KV.initMenu(item.sub, pageType, '', data.additionalData.menu, true);
                                        }
                                    }
                                });
                            }
                        }
                        break;
                    }
                    case 2: {
                        myApp.alert(data.message, data.title, function () {
                            console.log(data);
                            if (data.additionalData != undefined) {
                                console.log("test");
                                if (data.additionalData.page != undefined) {
                                    console.log("asdad");
                                    console.log(data);
                                    KV.getStaticPage(data.additionalData.page);
                                }
                            }
                        });
                        break;
                    }
                    case 3: {
                        KV.openPoll(null, {empty_text: "Henüz anket bulunmamaktadır."});
                        break;
                    }
                    case 4: {
                        var now = new Date();
                        now.addHours(3);
                        var iso = now.toISOString().match(/(\d{4}\-\d{2}\-\d{2})T(\d{2}:\d{2}:\d{2})/);
                        var filterDate = iso[1] + ' ' + iso[2];
                        var filters = {
                            "end_time": [">", filterDate],
                            "start_time": ["<", filterDate],
                            "active": ["=", "1"],
                            "registration": ["EMPTY OR IN", [activeID]],
                            "event_news_id": ["=", data.additionalData.news]
                        };
                        console.log(filters);
                        kvapi.get("/data/event/news", {
                            viewId: "mobile_app",
                            filters: JSON.stringify(filters)
                        }).then(function (res) {
                            console.log(res);
                            if (res.response.total) {
                                myApp.alert(data.message, data.title, function () {
                                    console.log(data);
                                    if (data.additionalData != undefined) {
                                        console.log("test");
                                        if (data.additionalData.news != undefined) {
                                            newsData = res.response.records[0];
                                            newsData.upData = "";
                                            newsData.back = "main.html";
                                            myApp.template7Data['page:newsDetail'] = newsData;
                                            mainView.router.load({
                                                url: 'newsDetail.html',
                                            });
                                        }
                                    }
                                });
                            }
                        });
                        break;
                    }
                    case 5: {
                        myApp.alert(data.message, data.title);
                        break;
                    }
                    case 6: {
                        if (data.additionalData.conversation != undefined) {

                            console.log(data.additionalData.conversation.conversation_label);
                            console.log(activeConversation);

                            if (activeConversation == data.additionalData.conversation.conversation_label && activeConversation) {
                                var msgTime = new Date();
                                var msg = {
                                    id: 0,
                                    text: data.additionalData.conversation.message,
                                    type: "received",
                                    day: "Bugün",
                                    time: (new Date()).toTimeString().split(' ')[0]
                                };
                                myApp.messages(".messages").appendMessage(msg);
                                //return;
                            }
                            myApp.alert(data.message, data.title, function () {
                                var conversationParams = data.additionalData.conversation;
                                conversationParams.toBack = 'main.html';
                                KV.toConverstaion(conversationParams);
                            });
                        }
                        break;
                    }
                }
            }
        }
        ,

        trUpperCase: function (input) {
            var inlineText = $$(input).val();
            inlineText = inlineText.replace(new RegExp('ğ', 'g'), 'Ğ');
            inlineText = inlineText.replace(new RegExp('ü', 'g'), 'Ü');
            inlineText = inlineText.replace(new RegExp('ş', 'g'), 'Ş');
            inlineText = inlineText.replace(new RegExp('i', 'g'), 'İ');
            inlineText = inlineText.replace(new RegExp('ö', 'g'), 'Ö');
            inlineText = inlineText.replace(new RegExp('ç', 'g'), 'Ç');
            inlineText = inlineText.replace(new RegExp('ı', 'g'), 'I');
            inlineText = inlineText.toUpperCase();
            $$(input).val(inlineText);
        },

        trCapitalize: function (input) {
            var inlineText = $$(input).val();
            var firstchar = inlineText.slice(0, 1);
            var lastchar = inlineText.slice(1);

            //first
            firstchar = firstchar.replace(new RegExp('ğ', 'g'), 'Ğ');
            firstchar = firstchar.replace(new RegExp('ü', 'g'), 'Ü');
            firstchar = firstchar.replace(new RegExp('ş', 'g'), 'Ş');
            firstchar = firstchar.replace(new RegExp('i', 'g'), 'İ');
            firstchar = firstchar.replace(new RegExp('ö', 'g'), 'Ö');
            firstchar = firstchar.replace(new RegExp('ç', 'g'), 'Ç');
            firstchar = firstchar.replace(new RegExp('ı', 'g'), 'I');

            //last
            lastchar = lastchar.replace(new RegExp('Ğ', 'g'), 'ğ');
            lastchar = lastchar.replace(new RegExp('Ü', 'g'), 'ü');
            lastchar = lastchar.replace(new RegExp('Ş', 'g'), 'ş');
            lastchar = lastchar.replace(new RegExp('İ', 'g'), 'i');
            lastchar = lastchar.replace(new RegExp('Ö', 'g'), 'ö');
            lastchar = lastchar.replace(new RegExp('Ç', 'g'), 'ç');
            lastchar = lastchar.replace(new RegExp('I', 'g'), 'ı');

            inlineText = firstchar.toUpperCase() + lastchar.toLowerCase();

            $$(input).val(inlineText);


        },

        dialogAnswer: function (t_this) {
            var lid = $$(t_this).attr('id');
            var inputClass = $$(t_this).attr("inputClass");

            var dialogInput = document.getElementById(lid).parentNode.querySelector('.' + inputClass);
            if ($$(dialogInput).is(":checked") && inputClass == 'poll-check') {
                return false;
            }
            var dialog = $$(dialogInput).attr("dialog");
            if (dialog == 1) {
                var item_title = document.getElementById(lid).parentNode.querySelector('.item-inner').querySelector('.item-title');
                //dialog_(item_title, dialogInput);
                var dialog_answer = $$(dialogInput).attr("dialog_answer");
                console.log(dialog_answer);
                myApp.modal({
                    title: $$(item_title).attr("org"),
                    text: 'Bu seçenek için giriş yapınız',
                    afterText: '<input type="text" class="modal-text-input" id="modal-text-input" value="' + dialog_answer + '">',
                    buttons: [{
                        text: 'OK',
                        onClick: function () {
                            var value = $$('#modal-text-input').val();
                            $$(item_title).html($$(item_title).attr("org") + ' (' + value + ')');
                            $$(dialogInput).attr("dialog_answer", value);
                        }
                    }, {
                        text: 'Cancel',
                        onClick: function () {
                        }
                    }]
                });
            }


        }
    }
;

kvapi.onTokenExpire = function (callback) {
    KV.getAccessToken(true, callback);
};

var deviceID = null;

document.addEventListener("deviceready", onDeviceReady, false);

function onDeviceReady() {
    deviceID = (device.uuid);
    if (deviceID) {
        console.log("Device ID", deviceID);
        KV.getAccessToken(false, function () {
            KV.getConfig();
        });
    }

    document.addEventListener("backbutton", function (e) {
        if (hardBackButton != 0) {
            hardBackButton--;
            return false;
        }
        var page = myApp.getCurrentView().activePage;
        myApp.hidePreloader();

        if (!popupOpen) {
            if (page.name == "quizQuestionsPage") {
                e.preventDefault();
            }
            else if (page.name == "main" && mainMenuDepth == 0) {
                e.preventDefault();
                var dialog = myApp.modal({
                    title: 'ONAY!',
                    text: 'Uygulamadan çıkılsın mı?',
                    buttons: [
                        {
                            text: 'Vazgeç',
                            onClick: function () {
                                myApp.closeModal(dialog);
                            }
                        },
                        {
                            text: 'Evet',
                            onClick: function () {
                                navigator.app.clearHistory();
                                navigator.app.exitApp();
                            }
                        }

                    ]
                });

            }
            else {
                if (myApp.mainView.history.length > 1) {
                    mainView.router.back({url: myApp.mainView.history[0], force: true})
                } else {
                    document.getElementsByClassName("back")[0].click();
                }
            }
        } else { // if photobrowser open
            $$('.close-popup').trigger("click");
        }
    }, false);


    $$('.external').on('click', function () {
        if (device.platform == "iOS") {
            var href = $$(this).attr("href");
            var ref = cordova.InAppBrowser.open(href, '_system', 'location=yes');
        }
    });

    //screen.lockOrientation('portrait');
    screen.orientation.lock('portrait');


}

Number.prototype.padLeft = function (base, chr) {
    var len = (String(base || 10).length - String(this).length) + 1;
    return len > 0 ? new Array(len).join(chr || '0') + this : this;
};
Date.prototype.addHours = function (h) {
    this.setTime(this.getTime() + (h * 60 * 60 * 1000));
    return this;
}


// deviceID = "6e0a5363f9a45fea"; //elif akpunar // Exhibitor and Contact Person
// deviceID = "ogrenci_kurum_test_device_id_7"; // Parent (Veli)
// deviceID = "9750F22D-BFAB-4E24-9C29-C045B7462480"; // Parent (Veli)
// deviceID = "6d58def9f6c75dc0";
// deviceID = "18913ad44c0f872ea";

// KV.getConfig();






