myApp.onPageInit('main', function (page) {
    console.log(page.context);
    var adBannerHtml = KV.gloabalBannerHtml;
    $$('#adBanner').html(adBannerHtml);
    $$('.navbar').removeClass('backgroundBlue').addClass('transparent');


    $$('.menu-item').on('click', function () {
        menuItemClick(this);
    });

    $$('.back').on('click', function () {
        KV.initMenu(KV.mainMenu)
    });


    $$('.external').on('click', function () {
        var href = $$(this).attr("href");
        var ref = cordova.InAppBrowser.open(href, '_system', 'location=yes');
    });
});

myApp.onPageInit('test', function (page) {
});


function menuItemClick(t_this) {
    var record_id = $$(t_this).attr("record_id");
    var upPageType = $$(t_this).attr("upPageType");
    if (upPageType == 'parentMenuExtended') {
        KV.activeExtended = record_id;
    }


    var item = KV.menu[record_id];


    if (item.sub) {
        var pageType = (item.pageType) ? item.pageType : null;
        KV.initMenu(item.sub, pageType, '', record_id, true);
    }
    else {
        // console.log("dsdsd");
        //
        // console.log("check_in_mandatory", item.check_in_mandatory);
        // console.log("check_in_mandator2y", JSON.parse((localStorage.getItem("userData"))).allUserData.checked_in);

        if (item.check_in_mandatory == 1 /*&& JSON.parse((localStorage.getItem("userData"))).allUserData.checked_in == 0*/) {

            if (item.event) {
                //var filter = {"event_registration_id": ["=", activeID]};

                // kvapi.get("/data/event/registration", {
                //     viewId: "mobile_app",
                //     filters: JSON.stringify(filter)
                // })
                //     .then(function (rs) {
                //         console.log(rs);
                //         if (rs.response.records[0].checked_in == 1) {
                //             userData = JSON.parse((localStorage.getItem("userData")));
                //             userData.allUserData.checked_in = rs.response.records.checked_in;
                //             localStorage.setItem("userData", JSON.stringify(userData));
                //             menuItemClick(t_this)
                //         } else {
                //             myApp.alert(item.menu_title_tr + " içeriğini görüntülemek için etkinlik alanına giriş yapmanız gerekmektedir.", "Dikkat!");
                //         }
                //     });
                var filter = {"registration": ["=", activeID], "event": ["=", item.event.value]};
                myApp.showIndicator();
                kvapi.get("/data/event/check_in", {
                    viewId: "mobile_app",
                    filters: JSON.stringify(filter)
                })
                    .then(function (rs) {
                        myApp.hideIndicator();
                        console.log(rs);
                        if (!rs.response.failed) {
                            if (rs.response.total < 1) {
                                myApp.alert(item.menu_title_tr + " içeriğini görüntülemek için etkinlik alanına giriş yapmanız gerekmektedir.", "Dikkat!");
                            } else {
                                openPage(item, upPageType);
                            }
                        } else {
                            myApp.alert("Bir hata oluştu. Lütfen yetkiliyle görüşünüz.", "Hata!");
                        }
                        // if (rs.response.records[0].checked_in == 1) {
                        //     userData = JSON.parse((localStorage.getItem("userData")));
                        //     userData.allUserData.checked_in = rs.response.records.checked_in;
                        //     localStorage.setItem("userData", JSON.stringify(userData));
                        //     menuItemClick(t_this)
                        // } else {
                        //     myApp.alert(item.menu_title_tr + " içeriğini görüntülemek için etkinlik alanına giriş yapmanız gerekmektedir.", "Dikkat!");
                        // }
                    });

            } else {
                myApp.alert(item.menu_title_tr + " içeriği görüntülenemiyor. Lütfen yetkiliyle görüşünüz. BYT-H01", "Dikkat!");
            }
        } else {

            openPage(item, upPageType);
        }
    }

}

function openPage(item, upPageType) {
    if (item.pageType == 'static') {
        KV.getStaticPage(item.route, 'static', upPageType);
    }
    if (item.pageType == 'dynamic') {
        KV.getStaticPage(item.route, 'dynamic', upPageType);
    }
}


myApp.onPageInit('mainExtended', function (page) {
    var adBannerHtml = KV.gloabalBannerHtml;
    $$('#adBanner').html(adBannerHtml);

    $$('.navbar').removeClass('transparent').addClass('backgroundBlue');
    var pickerInline = myApp.picker({
        input: '#picker-date',
        //container: '#picker-date-container',
        rotateEffect: true,
        toolbarCloseText: 'Göster',
        value: [page.context.pickerValue[page.context.index]],
        onClose: function (picker, values, displayValues) {
            KV.activeExtendedSubId = picker.value[0];
            KV.initMenu(page.context.menu, 'parentMenuExtended-2', picker.value[0]);
        },
        formatValue: function (p, values, displayValues) {
            return displayValues[0];
        },
        cols: [
            {
                displayValues: page.context.pickerLabel,
                values: page.context.pickerValue,
                textAlign: 'center'
            }
        ]
    });
    pickerInline.open();
    pickerInline.close();
    $$('.menu-item').on('click', function () {
        menuItemClick(this);
    });
    $$('.back').on('click', function () {
        KV.initMenu(KV.mainMenu);
    });

    $$('.external').on('click', function () {
        console.log("sds");
        var href = $$(this).attr("href");
        var ref = cordova.InAppBrowser.open(href, '_system', 'location=yes');
    });


});


myApp.onPageInit('quiz', function (page) {
    $$('.navbar').removeClass('transparent').addClass('backgroundBlue')
});

myApp.onPageInit('loginType', function (page) {

    KV.alignCenter('.login-buttons');

    $$('.login-button').on('click', function () {
        var typeId = $$(this).attr("typeId");
        var dt = {typeId: typeId};

        console.log(typeId);

        switch (typeId) {
            // case "6":
            //     rUrl = 'login.html';
            //     break;
            default:
                rUrl = 'signup.html';
        }
        mainView.router.load({
            reload: true,
            url: rUrl,
            context: dt,
        });

    });
});

myApp.onPageInit('login', function (page) {

    $$('.navbar').removeClass('backgroundBlue').addClass('transparent')
    KV.alignCenter('.loginDiv');

    $$(".back").on("click", function () {
        mainView.router.load({
            reload: true,
            url: 'loginType.html',
            context: '',
        });
    });

    $$("#kv_signup_new").on("click", function () {
        var typeId = $$(this).attr("type_id");

        var dt = {typeId: typeId};

        mainView.router.load({
            reload: true,
            url: 'signup.html',
            context: dt,
        });
    });

    $$('#kv_login').on("click", function () {
        var email = $$("#email").val();
        if (!email) {
            myApp.alert("Lütfen e-posta giriniz.", "Dikkat!")
        }

        else if ((KV.validateEmail(email) === false)) {
            myApp.alert("Geçerli bir e-posta adresi giriniz.", "Dikkat!")

        } else {
            //var filter = {"email": ["=", email], "event_name": ["=", KV.activeEvent]};
            var filter = {"email": ["=", email]};

            myApp.showIndicator();
            kvapi.get("/data/event/registration", {
                viewId: "mobile_app",
                filters: JSON.stringify(filter),
            })
                .then(function (rs) {
                    console.log(KV.activeEvent);
                    console.log(rs.response);
                    if (rs.response.total < 1) {
                        myApp.hideIndicator();

                        var dialog = myApp.modal({
                            title: 'Uyarı!',
                            // text: 'Bu e-posta aktif fuar için kayıtlı değildir.', // Contact kayıtlı olup registration olmayabilir dikkat ediniz.
                            text: 'Bu e-posta kayıtlı değildir.', // Contact kayıtlı olup registration olmayabilir dikkat ediniz.
                            buttons: [
                                {
                                    text: 'Vazgeç',
                                    onClick: function () {
                                        myApp.closeModal(dialog);
                                    }
                                },
                                {
                                    text: 'Yeni Kayıt',
                                    onClick: function () {
                                        mainView.router.load({
                                            reload: true,
                                            url: "loginType.html",
                                            context: "",
                                        });
                                    }
                                },

                            ]
                        });
                    } else {
                        var registration_id = rs.response.records[0].registration_id;
                        var filter = {
                            "registration": ["=", registration_id],
                            "device_id": ["=", deviceID]
                        };

                        kvapi.get("/data/cms/mobile_device", {
                            viewId: "mobile_app",
                            filters: JSON.stringify(filter),
                        })
                            .then(function (rs) {
                                myApp.hideIndicator();
                                if (rs.response.total < 1) {
                                    var dialog = myApp.modal({
                                        title: 'Uyarı!',
                                        text: 'Bu cihazı kullanılabilir cihazlarınıza eklemelisiniz.',
                                        buttons: [
                                            {
                                                text: 'Vazgeç',
                                                onClick: function () {
                                                    myApp.closeModal(dialog);
                                                }
                                            },
                                            {
                                                text: 'Ekle',
                                                onClick: function () {

                                                    var mobileDeviceObj = {
                                                        registration: registration_id,
                                                        email: email,
                                                        event_name: KV.activeEvent,
                                                        device_id: deviceID
                                                    };

                                                    try {
                                                        KV.push = PushNotification.init({
                                                            android: {
                                                                senderID: "129613237013",
                                                                sound: true,
                                                                vibrate: true,
                                                                topics: ['all', 'android', 'userType6']
                                                            },
                                                            ios: {
                                                                alert: true,
                                                                badge: true,
                                                                clearBadge: true,
                                                                sound: true,
                                                                senderID: "129613237013",
                                                                gcmSandbox: true,
                                                                topics: ['all', 'ios', 'userType6']
                                                            },
                                                            windows: {}
                                                        });

                                                        KV.push.on('registration', function (data) {

                                                            mobileDeviceObj.push_token = data.registrationId;
                                                            mobileDeviceObj.device_platform = device.platform;
                                                            mobileDeviceObj.device_model = device.model;

                                                            localStorage.setItem("pushRegistrationId", data.registrationId);

                                                            console.log("mobileDeviceObj", mobileDeviceObj);

                                                            kvapi.post("/data/cms/mobile_device", {
                                                                //triggerWF: true, // iş akışı kuralı var ise çalıştır
                                                                upsert: true, // mükerrer kayıt var ise güncelle
                                                                upsertFields: ["device_id"],
                                                                upsertIfEmpty: true,
                                                                records: [
                                                                    mobileDeviceObj
                                                                ]
                                                            })
                                                                .then(function (response) {
                                                                    console.log("device_kayıt", response);
                                                                    if (response.response.success) {
                                                                        if (response.response.failed) {
                                                                            myApp.alert("Bir hata oluştu. Lütfen yetkiliyle görüşünüz. F.101");
                                                                            return false;
                                                                        }
                                                                        // myApp.alert("Aktivasyon E-Posta'sı tarafınıza iletilmiştir. E-Posta kutunuza gelen aktivasyon bağlantısına tıklayarak onay işlemini tamamlayabilirsiniz.", "E-Posta Onayı");
                                                                        KV.getConfig();
                                                                    }
                                                                })
                                                                .catch(function (rs) {
                                                                    console.log("KV:301-3 : Failde To Save.", "Hata!");

                                                                });
                                                        });

                                                        KV.push.on('notification', function (data) {

                                                            KV.push.setApplicationIconBadgeNumber(function () {
                                                                //console.log('success');
                                                            }, function () {
                                                                //console.log('error');
                                                            }, 0);

                                                            myApp.alert(data.message, data.title, function () {
                                                                if (data.additionalData != undefined) {
                                                                    if (data.additionalData.route != undefined) {
                                                                        KV.getStaticPage(data.additionalData.route);
                                                                    }
                                                                }
                                                            });
                                                        });

                                                        KV.push.on('error', function (e) {
                                                            console.log(e)
                                                        });
                                                    } catch (err) {
                                                        console.log(err);
                                                    }
                                                }
                                            },

                                        ]
                                    });
                                } else {
                                    if (!rs.response.records[0].active) {
                                        // myApp.alert("Uygulamaya girebilmek için e-postanıza gelen bağlantıyı tıklayarak onaylayınız.", "E-Posta Onayı");
                                        KV.getConfig();
                                    } else {
                                        //myApp.alert("Onaylı cihaz", "ONAY");
                                        KV.getConfig();

                                    }
                                }

                            })
                            .catch(function (rs) {
                                myApp.hideIndicator();
                                console.log(rs);
                            });
                    }
                })
                .catch(function (rs) {
                    myApp.hideIndicator();
                    console.log(rs);
                });
        }

    });
});





