myApp.onPageInit('qrContactList', function (page) {
    $$('.back').on('click', function () {
        mainView.router.back({url: 'main.html', force: true})
    });
    $$('.navbar').removeClass('transparent').addClass('backgroundBlue');
    $$('.contact_item').on('click', function () {
        var recordIndex = $$(this).attr("r_index");
        var recordKey = $$(this).attr("r_key");
        var rs = KV.qrContactList[recordKey][recordIndex];
        rs.up = page.context;
        rs.added_time = KV.setDate(rs.created_on);

        myApp.template7Data['page:qrContactDetail'] = rs;
        mainView.router.load({
            reload: true,
            url: "qrContactDetail.html",
        });
    });


    $$('#sendMyContacs').on("click", function () {
        //alert("katılımcılar gönderilecek");
        var email = (JSON.parse((localStorage.getItem("userData"))).allUserData.email);
        myApp.showIndicator();
        var recObj = {
            //event: page.context.event_id,
            registration: activeID,
            email: email,
            requested_data: 1,
        }

        kvapi.post("/data/educaturk/data_gonderimi", {
            records: [
                recObj
            ]
        }).then(function (cb) {
            myApp.hideIndicator();
            console.log(cb);
            if (cb.response.success) {
                myApp.alert("İletişim Listeniz e-posta adresinize birkaç dakika içinde iletilecektir.", "Bilgi")

            } else {
                myApp.alert("Liste gönderilemedi. Daha sonra tekrar deneyeniz.", "Hata!")

            }

        }).catch(function () {
            myApp.hideIndicator();
            myApp.alert("Liste gönderilemedi. Daha sonra tekrar deneyeniz.", "Hata!")
        });
    });

});

myApp.onPageInit('qrContactDetail', function (page) {
    console.log(page.context);
    $$('.back').on('click', function () {
        mainView.router.back({url: 'qrContactList.html', force: true})
    });

});


myApp.onPageInit('createQr', function (page) {
    //console.log(page.context);
    $$('svg').css({'width': '90%'});
    $$('.back').on('click', function () {
        mainView.router.back({url: 'main.html', force: true})
    });
    $$('.navbar').removeClass('transparent').addClass('backgroundBlue')

});

myApp.onPageInit('qrContactReader', function (page) {
    $$('.navbar').removeClass('transparent').addClass('backgroundBlue')
    function decodeBarcodeText(text) {
        var splitedText = text.split("|");

        var obj = {
            registration: activeID,
            fullname: splitedText[0],
            organization: splitedText[1],
            email: splitedText[2],
            phone: splitedText[3],
            title: splitedText[4]
        };

        return obj;
    }

    // $$('#openQrReader').on('click', function () {

    cordova.plugins.barcodeScanner.scan(
        function (result) {
            if (result.cancelled == 0 && result.text) {
                kvapi.post("/data/networking/contact_list", {
                    //triggerWF: true, // iş akışı kuralı var ise çalıştır
                    upsert: true, // mükerrer kayıt var ise güncelle
                    upsertFields: ["phone"],
                    upsertIfEmpty: true,
                    records: [
                        decodeBarcodeText(result.text)
                    ]
                })
                    .then(function (rs) {
                        alert(JSON.stringify((rs)));

                    })
                    .catch(function (rs) {
                        alert(JSON.stringify((rs)));

                    });
            }
        },
        function (error) {
            alert("Scanning failed: " + error);
        },
        {
            "preferFrontCamera": false, // iOS and Android
            "showFlipCameraButton": false, // iOS and Android
            "prompt": "Place a barcode inside the scan area", // supported on Android only
            "formats": "QR_CODE", // default: all but PDF_417 and RSS_EXPANDED
            "orientation": "landscape" // Android only (portrait|landscape), default unset so it rotates with the device
        }
    );
    //});
});