myApp.onPageInit('signup', function (page) {

    $$('.signFirstStep').show();
    $$('.signLastStep').hide();
    //console.log(KV.userPolicy);
    $$('.userPolicy').attr("href", KV.userPolicy);
    //KV.alignCenter(".signupDiv");
    var formId = '#signupForm_' + page.context.typeId;
    $$('.kv_signup_email_control').on('click', function () {


        var email = $$(formId + " #email").val().trim();

        if (!email) {
            myApp.alert("Gerekli alanları doldurunuz.", "Dikkat!")
        } else if ((KV.validateEmail(email) === false)) {
            myApp.alert("Geçerli bir email adresi giriniz.", "Dikkat!")
        } else {

            var filter = {"email": ["=", email]};
            myApp.showIndicator();
            kvapi.get("/data/event/registration", {
                viewId: "mobile_app",
                filters: JSON.stringify(filter),
            })
                .then(function (response) {
                    console.log(response);
                    myApp.hideIndicator();

                    var data = response.response.records;

                    // Email varsa
                    if (data.length > 0) {
                        var dialog = myApp.modal({
                            title: 'Dikkat!',
                            text: 'Bu E-Posta ile daha önceden kayıt yapılmıştır.',
                            buttons: [

                                {
                                    text: 'Giriş',
                                    onClick: function () {
                                        mainView.router.load({
                                            reload: true,
                                            url: "login.html",
                                            context: {email: email},
                                        });
                                    }
                                },
                                {
                                    text: 'Yeni E-Posta',
                                    onClick: function () {
                                        myApp.closeModal(dialog);
                                        //$$(formId + " #email").val("");
                                    }
                                }

                            ]
                        });
                    }
                    // Email Yoksa - Kayıt Yapılacak
                    else {

                        if (formId === '#signupForm_6') {
                            emailArr = email.split('@');
                            var filter = {"email_extension": ["=", emailArr[1]]};
                            myApp.showIndicator();

                            kvapi.get("/data/crm/account", {
                                viewId: "mobile_app",
                                filters: JSON.stringify(filter),
                            })
                                .then(function (response) {
                                    myApp.hideIndicator();

                                    if (response.response.total > 0) {
                                        console.log(response.response);
                                        var filter = {"organization": ["=", response.response.records[0].record_id]};
                                        kvapi.get("/data/event/exhibitor", {
                                            viewId: "mobile_app",
                                            filters: JSON.stringify(filter),
                                        })
                                            .then(function (response2) {
                                                console.log(response2.response);
                                                if (response2.response.total > 0) {
                                                    $$(formId + ' .signFirstStep').hide();
                                                    $$(formId + ' .signLastStep').show();
                                                    $$(formId + " #organization").val(response.response.records[0].account_name);
                                                    $$(formId + " #organization").attr('id_val', response.response.records[0].record_id);
                                                } else {
                                                    myApp.alert("Sadece Educaturk katılımcıları bu profilden giriş yapabilir.", "Dikkat!")
                                                }
                                            }).catch(function (response2) {

                                        });


                                    } else {
                                        myApp.alert("Sadece Educaturk katılımcıları bu profilden giriş yapabilir.", "Dikkat!")
                                    }
                                }).catch(function (response) {
                                myApp.hideIndicator();
                            });
                        } else {
                            $$(formId + ' .signFirstStep').hide();
                            $$(formId + ' .signLastStep').show();
                            $$(formId + " #organization").val(response.response.records[0].account_name);
                            $$(formId + " #organization").attr('id_val', response.response.records[0].record_id);
                        }
                    }
                }).catch(function (response) {
                myApp.hideIndicator();
                console.log("KV:301-2 : Failde To Save.", "Hata!");


            });
        }
    });

    $$('.kv_signup_email_control2').on('click', function () {
        var form = $$(this).closest("form").attr('id');
        console.log(form);

    });

    $$(".back").on("click", function () {
        mainView.router.load({
            reload: true,
            url: "loginType.html",
            context: "",
        });
    });

    $$(formId + " #phone").on("keyup", function () {
        var phoneVal = $$(this).val();
        //console.log(phoneVal.substr(0, 1));
        if (phoneVal.substr(0, 1) != 0) {
            $$(this).val("0" + phoneVal);
        }
    });
    var sTypes = ["", "Genel", "Öğretmen", "Öğrenci", "Konuşmacı", "Veli", "Katılımcı"];
    $$(".kv_signup").on("click", function () {
        var email = $$(formId + " #email").val().trim();

        // get Fields
        var firstname = $$(formId + " #firstname").val().trim();
        var lastname = $$(formId + " #lastname").val().trim();
        var phone = $$(formId + " #phone").val().trim();
        phone = phone.replace(/[^0-9]/g, '');


        var show_only_users = page.context.typeId;
        var registrationObj = {};
        ctrl = 1;
        if (!show_only_users) {
            ctrl = 0;
            console.log("KV:302 : No show_only_users.", "Hata!");
        }
        else if (page.context.typeId == 5) {   // Tercih fuarı zamanı eklenen veli
            var cityID = $$(formId + " #cityID").val();
            if (!firstname || !lastname || !email || !cityID) {
                ctrl = 0;
                myApp.alert("Gerekli alanları doldurunuz.", "Dikkat!");
            }
            registrationObj.address_city = cityID;
        }
        else if (page.context.typeId == 2 || page.context.typeId == 3) {
            if (!firstname || !lastname || !email || !$$(formId + " #organization").val().trim()) {
                ctrl = 0;
                myApp.alert("Gerekli alanları doldurunuz.", "Dikkat!");
            }
            // if (page.context.typeId == 2 && !$$(formId + " #organization").val().trim()) {
            //     ctrl = 0;
            //     myApp.alert("Gerekli alanları doldurunuz.", "Dikkat!");
            // }
            if (page.context.typeId == 2 && ctrl == 1) {
                var cityID = $$(formId + " #cityID2").val();
                var title = $$(formId + " #title").val();
                if (!cityID || !title) {
                    ctrl = 0;
                    myApp.alert("Gerekli alanları doldurunuz.", "Dikkat!");
                }
                registrationObj.address_city = cityID;
                registrationObj.title = title;
            }
            if (page.context.typeId == 3 && ctrl == 1) {
                var classroom = $$(formId + " #classroom").val();

                if (classroom == "Mezun") {
                    classroom = 4;
                }
                var department = $$(formId + " #department").val();
                var cityID = $$(formId + " #cityID").val();
                if (!classroom || !cityID || !department) {
                    ctrl = 0;
                    myApp.alert("Gerekli alanları doldurunuz.", "Dikkat!");
                }
                registrationObj.classroom = classroom;
                registrationObj.address_city = cityID;
                registrationObj.student_department = depArrayIDs[department];

            }
            registrationObj.organization_non_exhibitor = $$(formId + " #organization").val().trim();
        }

        else if (page.context.typeId == 6) {
            if (!firstname || !lastname || !email) {
                ctrl = 0;
                myApp.alert("Gerekli alanları doldurunuz.", "Dikkat!")
            }
            registrationObj.organization = $$(formId + " #organization").attr('id_val');
        }
        else if (!phone) {
            ctrl = 0;
            myApp.alert("Geçerli Bir Telefon Giriniz. Örn: 05321112233", "Dikkat!");
        }
        if (ctrl == 1)
            if ((KV.validateEmail(email) === false)) {
                $ctrl = 0;
                myApp.alert("Geçerli bir email adresi giriniz.", "Dikkat!")
            }
            else if (phone.length != 11) {
                ctrl = 0;
                myApp.alert("Geçerli Bir Telefon Giriniz. Örn: 05321112233", "Dikkat!");
            }

            else if (!$$(formId + " #userPolicy").is(":checked")) {
                ctrl = 0;
                myApp.alert("Kullanıcı sözleşmesini kabul etmelisiniz.", "Dikkat!");
            }
            else {
                myApp.showIndicator();
                var filter = {"email": ["=", email]};
                kvapi.get("/data/event/registration", {
                    viewId: "mobile_app",
                    filters: JSON.stringify(filter),
                })
                    .then(function (response) {
                        //myApp.hideIndicator();
                        var data = response.response;
                        //console.log(response.response.total > 1)
                        var contactObj = {
                            firstname: firstname,
                            lastname: lastname,
                            phone: phone,
                            email: email
                        };
                        registrationObj.show_only_users = show_only_users;
                        registrationObj.event = "";
                        registrationObj.firstname = firstname;
                        registrationObj.lastname = lastname;
                        registrationObj.email = email;
                        registrationObj.event_name = KV.activeEvent;
                        if (response.response.total > 0) {
                            if (page.context.typeId != response.response.records[0].show_only_users.value) {
                                console.log(sTypes);
                                console.log(response.response.records[0].show_only_users.value);
                                myApp.alert("Bu email ile daha önce " + sTypes[response.response.records[0].show_only_users.value] + " profili ile kayıt olunmuş. Lütfen bu profille giriş yapınız.", "Dikkat!")
                                myApp.hideIndicator();
                            } else {
                                contactSign(contactObj, registrationObj)
                            }
                        }
                        else {
                            contactSign(contactObj, registrationObj)
                        }

                    });
                //return false;

                // .catch(function (rs) {
                //     myApp.alert("Lütfen yetkiliyle görüşünüz.","Hata!")
                //     //console.log("KV:301-1 : Failde To Save.", "Hata!");
                // });
            }
    });

    function contactSign(contactObj, registrationObj) {

        kvapi.post("/data/crm/contact", {
            //triggerWF: true, // iş akışı kuralı var ise çalıştır
            upsert: false,
            records: [
                contactObj
            ]
        })
            .then(function (rs) {
                    console.log("crm_contact post cevabı = ", rs.response);
                    //registrationObj.show_only_users = show_only_users;
                    registrationObj.part_contact = rs.response.records[0].record_id;

                    if (rs.response.failed) {
                        if (rs.response.records[0].error == "DUPLICATE_RECORD") {
                            rs.response.records[0].record_id = rs.response.records[0].duplicate_record_id;
                            registrationObj.part_contact = rs.response.records[0].duplicate_record_id;
                            registrationSign(rs, registrationObj);
                        } else {
                            myApp.alert("Kayıt yapılamıyor. Lütfen yetkiliyle görüşünüz. BYT-KHC01", "Hata!");
                            return false;
                        }
                    }
                    else {
                        registrationSign(rs, registrationObj);
                    }
                    /*{

                     // REGISTRATION KAYDET
                     registrationObj.event = "";
                     registrationObj.part_contact = rs.response.records[0].record_id;
                     registrationObj.firstname = firstname;
                     registrationObj.lastname = lastname;
                     registrationObj.email = email;
                     registrationObj.show_only_users = show_only_users;
                     registrationObj.event_name = KV.activeEvent;

                     console.log(registrationObj);


                     kvapi.post("/data/event/registration", {
                     //triggerWF: true, // iş akışı kuralı var ise çalıştır
                     upsert: false,

                     records: [
                     registrationObj
                     ]
                     })
                     .then(function (rs) {
                     // MOBILE DEVICE KAYDET
                     console.log("event_registration post cevabı = ", rs.response);
                     if (rs.response.records[0].error == "DUPLICATE_RECORD") {
                     myApp.modal({
                     title: 'Dikkat!',
                     text: 'Bu mail adresi ile daha önce bir profil oluşturdunuz, bu profil ile devam etmek istiyor musunuz?',
                     buttons: [
                     {
                     text: 'İptal',
                     onClick: function () {
                     myApp.alert("Yeni bir mail adresi yazarak yeniden kayıt olmayı deneyebilirsiniz.", "Bilgi");
                     myApp.hideIndicator();
                     }
                     },
                     {
                     text: 'Evet',
                     onClick: function () {
                     rs.response.records[0].record_id = rs.response.records[0].duplicate_record_id;
                     }
                     }
                     ]
                     });
                     } else {
                     myApp.alert("Bir hata oluştu. Lütfen yetkiliyle görüşünüz.", "Hata!");
                     return false;
                     }

                     var mobileDeviceObj = {
                     registration: rs.response.records[0].record_id,
                     email: email,
                     event_name: KV.activeEvent,
                     device_id: deviceID
                     };


                     KV.push = PushNotification.init({
                     android: {
                     senderID: "129613237013",
                     sound: true,
                     vibrate: true,
                     topics: ['all', 'android', 'userType' + show_only_users]
                     },
                     ios: {
                     alert: true,
                     badge: true,
                     clearBadge: true,
                     sound: true,
                     senderID: "129613237013",
                     gcmSandbox: false,
                     topics: ['all', 'ios', 'userType' + show_only_users]
                     },
                     windows: {}
                     });


                     KV.push.on('registration', function (data) {
                     // data.registrationId

                     mobileDeviceObj.push_token = data.registrationId;
                     mobileDeviceObj.device_platform = device.platform;
                     mobileDeviceObj.device_model = device.model;

                     localStorage.setItem("pushRegistrationId", data.registrationId);

                     kvapi.post("/data/cms/mobile_device", {
                     //triggerWF: true, // iş akışı kuralı var ise çalıştır
                     upsert: true,
                     records: [
                     mobileDeviceObj
                     ]
                     })
                     .then(function (response) {
                     myApp.hideIndicator();
                     myApp.alert("Sayın " + firstname + " " + lastname + " Başarıyla Kayıt Oldunuz.", "Başarılı!", function () {
                     $$('#sg1').hide();
                     KV.getConfig();
                     });
                     });
                     });

                     KV.push.on('notification', function (data) {

                     KV.push.setApplicationIconBadgeNumber(function () {
                     //console.log('success');
                     }, function () {
                     //console.log('error');
                     }, 0);

                     myApp.alert(data.message, data.title, function () {
                     if (data.additionalData != undefined) {
                     if (data.additionalData.route != undefined) {
                     KV.getStaticPage(data.additionalData.route);
                     }
                     }
                     });
                     });
                     KV.push.on('error', function (e) {
                     console.log(e)
                     });

                     });
                     }*/

                }
            )
    }

    function registrationSign(rs, registrationObj) {

        console.log(registrationObj);


        kvapi.post("/data/event/registration", {
            //triggerWF: true, // iş akışı kuralı var ise çalıştır
            upsert: false,
            records: [
                registrationObj
            ]
        })
            .then(function (rs) {
                // MOBILE DEVICE KAYDET
                console.log("sdsd", rs);
                if (rs.response.failed) {
                    if (rs.response.records[0].error == "DUPLICATE_RECORD") {
                        myApp.modal({
                            title: 'Dikkat!',
                            text: 'Bu mail adresi ile daha önce bir profil oluşturdunuz, bu profil ile devam etmek istiyor musunuz?',
                            buttons: [
                                {
                                    text: 'İptal',
                                    onClick: function () {
                                        myApp.alert("Yeni bir mail adresi yazarak yeniden kayıt olmayı deneyebilirsiniz.", "Bilgi");
                                        myApp.hideIndicator();
                                    }
                                },
                                {
                                    text: 'Evet',
                                    onClick: function () {
                                        rs.response.records[0].record_id = rs.response.records[0].duplicate_record_id;
                                        mobileDeviceSign(rs, registrationObj.email);
                                    }
                                }
                            ]
                        });
                    } else {
                        myApp.alert("Kayıt yapılamıyor. Lütfen yetkiliyle görüşünüz. BYT-KHR01", "Hata!");
                        return false;
                    }
                } else {
                    mobileDeviceSign(rs, registrationObj.email);
                }
            });
    }

    function mobileDeviceSign(rs, email) {

        var mobileDeviceObj = {
            registration: rs.response.records[0].record_id,
            email: email,
            event_name: KV.activeEvent,
            device_id: deviceID
        };
        //console.log(mobileDeviceObj);
        var show_only_users = page.context.typeId;
        KV.push = PushNotification.init({
            android: {
                senderID: "129613237013",
                sound: true,
                vibrate: true,
                topics: ['all', 'android', 'userType' + show_only_users]
            },
            ios: {
                alert: true,
                badge: true,
                clearBadge: true,
                sound: true,
                senderID: "129613237013",
                gcmSandbox: false,
                topics: ['all', 'ios', 'userType' + show_only_users]
            },
            windows: {}
        });

        KV.push.on('error', function (e) {
            console.log(e);

            mobileDeviceObj.device_platform = device.platform;
            mobileDeviceObj.device_model = device.model;
            mobileDeviceObj.status = 1;

            kvapi.post("/data/cms/mobile_device", {
                //triggerWF: true, // iş akışı kuralı var ise çalıştır
                upsert: true,
                records: [
                    mobileDeviceObj
                ]
            })
                .then(function (response) {
                    //console.log(response);
                    myApp.hideIndicator();
                    if (response.response.failed) {
                        if (response.response.records[0].error == "DUPLICATE_RECORD_IN_TRASH") {
                            myApp.alert("Kayıt yapılamıyor. Lütfen yetkiliyle görüşünüz. BYT-KHM01", "Hata!");
                        } else {
                            myApp.alert("Kayıt yapılamıyor. Lütfen yetkiliyle görüşünüz. BYT-KHM02", "Hata!");
                        }
                        return;
                    }
                    myApp.alert("Başarıyla Kayıt Oldunuz.", "Başarılı!", function () {
                        $$('#sg1').hide();
                        KV.getConfig();
                    });
                });
        });

        KV.push.on('registration', function (data) {
            // data.registrationId

            mobileDeviceObj.push_token = data.registrationId;
            mobileDeviceObj.device_platform = device.platform;
            mobileDeviceObj.device_model = device.model;
            mobileDeviceObj.status = 1;

            localStorage.setItem("pushRegistrationId", data.registrationId);

            kvapi.post("/data/cms/mobile_device", {
                //triggerWF: true, // iş akışı kuralı var ise çalıştır
                upsert: true,
                records: [
                    mobileDeviceObj
                ]
            })
                .then(function (response) {
                    //console.log(response);
                    myApp.hideIndicator();
                    if (response.response.failed) {
                        if (response.response.records[0].error == "DUPLICATE_RECORD_IN_TRASH") {
                            myApp.alert("Kayıt yapılamıyor. Lütfen yetkiliyle görüşünüz. BYT-KHM01", "Hata!");
                        } else {
                            myApp.alert("Kayıt yapılamıyor. Lütfen yetkiliyle görüşünüz. BYT-KHM02", "Hata!");
                        }
                        return;
                    }
                    myApp.alert("Başarıyla Kayıt Oldunuz.", "Başarılı!", function () {
                        $$('#sg1').hide();
                        KV.getConfig();
                    });
                });
        });
        KV.push.on('notification', function (data) {
            //console.log(data);
            KV.push.setApplicationIconBadgeNumber(function () {
                //console.log('success');
            }, function () {
                //console.log('error');
            }, 0);
            //console.log("type", data.additionalData.notification_type);

            // myApp.alert(data.message, data.title, function () {
            //     if (data.additionalData != undefined) {
            //         if (data.additionalData.route != undefined) {
            //             KV.getStaticPage(data.additionalData.route);
            //         }
            //     }
            // });
            if (data.additionalData.notification_type == 1) {
                var item = KV.menu[data.additionalData.menu];
                if (item) {
                    if (item.sub) {
                        myApp.alert(data.message, data.title, function () {
                            if (data.additionalData != undefined) {
                                if (data.additionalData.menu != undefined) {
                                    KV.activeExtended = data.additionalData.menu;
                                    var pageType = (item.pageType) ? item.pageType : null;
                                    KV.initMenu(item.sub, pageType, '', data.additionalData.menu, true);
                                }
                            }
                        });
                    }
                }
            }
            if (data.additionalData.notification_type == 2) {
                myApp.alert(data.message, data.title, function () {
                    console.log(data);
                    if (data.additionalData != undefined) {
                        console.log("test");
                        if (data.additionalData.page != undefined) {
                            console.log("asdad");
                            console.log(data);
                            KV.getStaticPage(data.additionalData.page);
                        }
                    }
                });
            }
            if (data.additionalData.notification_type == 3) {
                KV.openPoll(null, {empty_text: "Henüz anket bulunmamaktadır."});
            }
            if (data.additionalData.notification_type == 4) {
                var now = new Date();
                now.addHours(3);
                var iso = now.toISOString().match(/(\d{4}\-\d{2}\-\d{2})T(\d{2}:\d{2}:\d{2})/);
                var filterDate = iso[1] + ' ' + iso[2];
                var filters = {
                    "end_time": [">", filterDate],
                    "start_time": ["<", filterDate],
                    "active": ["=", "1"],
                    "registration": ["EMPTY OR IN", [activeID]],
                    "event_news_id": ["=", data.additionalData.news]
                };
                console.log(filters);
                kvapi.get("/data/event/news", {
                    viewId: "mobile_app",
                    filters: JSON.stringify(filters)
                }).then(function (res) {
                    console.log(res);
                    if (res.response.total) {
                        myApp.alert(data.message, data.title, function () {
                            console.log(data);
                            if (data.additionalData != undefined) {
                                console.log("test");
                                if (data.additionalData.news != undefined) {
                                    newsData = res.response.records[0];
                                    newsData.upData = "";
                                    newsData.back = "main.html";
                                    myApp.template7Data['page:newsDetail'] = newsData;
                                    mainView.router.load({
                                        url: 'newsDetail.html',
                                    });
                                }
                            }
                        });
                    }
                });
            }
            if (data.additionalData.notification_type == 5) {
                myApp.alert(data.message, data.title);
            }
            if (data.additionalData.notification_type == 6) {
                if (data.additionalData.conversation != undefined) {

                    //console.log(data.additionalData.conversation.conversation_label);
                    //console.log(activeConversation);

                    if (typeof data.additionalData.conversation == "string") {
                        data.additionalData.conversation = JSON.parse(data.additionalData.conversation);
                        //console.log("Conversation: ", data.additionalData.conversation);
                    }

                    if (activeConversation == data.additionalData.conversation.conversation_label && activeConversation) {
                        var msgTime = new Date();
                        var msg = {
                            id: 0,
                            text: data.additionalData.conversation.message,
                            type: "received",
                            day: "Bugün",
                            time: (new Date()).toTimeString().split(' ')[0]
                        };
                        myApp.messages(".messages").appendMessage(msg);
                        return;
                    }
                    myApp.alert(data.message, data.title, function () {
                        var conversationParams = data.additionalData.conversation;
                        conversationParams.toBack = 'main.html';
                        KV.toConverstaion(conversationParams);
                    });
                }
            }
        });
    }

    $$("[type=search]").keyup(function (event) {
        KV.trCapitalize(this, "capitalize");
    });

    var cities = [];
    $$.getJSON('json/cities.json', function (data) {
        cities = data;
    });

    var nt = '' +
        '<div class="navbar"> ' +
        '<div class="navbar-inner navbar-on-center">' +
        '<div class="left sliding"> ' +
        ' <a href="#" class="link back">' +
        '<i class="fa fa-chevron-left kvBack {{iconsColorClass}}"></i>' +
        'Geri</a> </div> <div class="center sliding"> ' +
        '{{pageTitle}} ' +
        '</div> </div> </div> '

    var autocompleteCity = myApp.autocomplete({
        openIn: 'page', //open in page
        opener: $$('#autocomplete-city'), //link that opens autocomplete
        backOnSelect: true, //go back after we select something
        navbarTemplate: nt,
        searchbarPlaceholderText: 'Şehir adı giriniz',
        searchbarCancelText: 'Vazgeç',
        notFoundText: 'Bulunamadı...',
        source: function (autocomplete, query, render) {
            var results = [];
            if (query.length === 0) {
                render(results);
                return;
            }
            // Find matched items
            for (var i = 0; i < cities.length; i++) {
                label = cities[i].city_name;
                if (label.toLowerCase().indexOf(query.toLowerCase()) >= 0) results.push(cities[i].city_name);
            }
            // Render items by passing array with result items
            render(results);
        },
        onChange: function (autocomplete, value) {
            // Add item text value to item-after
            //$$('#autocomplete-standalone3').find('.label').text(value[0]);
            // Add item value to input value
            $$('#autocomplete-city').find('input').val(value[0]);
            for (var i = 0; i < cities.length; i++) {
                label = cities[i].city_name;
                if (label.indexOf(value[0]) >= 0) {
                    selectedItemId = cities[i].addr_city_id;
                    $$('#autocomplete-city').find('#cityID').val(selectedItemId);
                }
            }
        },
        onClose: function () {
            $$('.navbar').removeClass('backgroundBlue').addClass('transparent').css('z-index', -1);
        },
        onOpen: function () {
            $$('.navbar').removeClass('transparent').addClass('backgroundBlue').css('z-index', 999);
        }
    });

    var pickerClassroom = myApp.picker({
        toolbarCloseText: 'Seç',
        input: '#classroom',
        cols: [
            {
                textAlign: 'center',
                values: ['Mezun', '12', '11', '10']
            }
        ]
    });


    var depArrayIDs = {"Fen": "1", "Sosyal": "2", "TM": "3", "Dil": "4"};
    var depArray = ['Fen', 'Sosyal', 'TM', 'Dil'];
    var pickerDepartment = myApp.picker({
        toolbarCloseText: 'Seç',
        input: '#department',
        cols: [
            {
                textAlign: 'center',
                values: depArray
            }
        ]
    });

    $$(".customAutoComplete-opener").on("click", function () {
        KV.customAutoComplete(this);
    });

    $$('.popup-customAutoComplete').on('open', function () {
        popupOpen = 1;
        $$('.navbar').removeClass('transparent').addClass('backgroundBlue').css("z-index", 999);
        $$('#myBack').addClass("close-popup");
    });

    $$('.popup-customAutoComplete').on('close', function () {
        popupOpen = 0;
        $$('.navbar').removeClass('backgroundBlue').addClass('transparent').css("z-index", -1);
        $$('#myBack').removeClass("close-popup");
    });
});

